File:  changes.txt  (C) C.R. Henderson, 1997-2010

Latest Build Date:

A.00.201 [Sep  7 2010 14:00]

See NOTES at end of file.

======================================================================
A.00.201
Sept 7, 2010
          Fixed a route upload bug affecting all units using waypoint
          data record D150-D155.

May 3, 2010
          Opened COM port range to COM255.

Jan 10, 2010
          Modified the reading of Garmin POI files in .csv format
          slightly.  If a .csv file exactly follows the format shown
          in the POI Loader helpfile then G7ToWin should read the file.
          One caveat...G7ToWin can read names and comments that are
          quoted (") or not, but it cannot read files that use multiple
          quotes, i.e.  """<comment>""" will cause G7ToWin to fail. I
          may or may not fix this problem.

Dec 26, 2009
          Sorting a column in a list immediately after moving a column
          would cause the column order to be reset. Fixed.

          Column widths could not be set to zero.  Setting a column
          width to zero caused the column width to be reset to the
          default width for that column.  This is no longer the case.
          Column widths can be set to zero and reset to the defaults
          via a right click on the list.

          NOTE: Column widths are set by dragging the right edge to
                the left.

Dec 22, 2009
          Changed the order of some extensions in .gpx files to enable
          the POI loader to read POIs from .gpx files created by
          G7ToWin.

Oct 30, 2009
          Added search for next TP > 1 hour in track lists.

Sept 26, 2009
          Added the ability to save Track Link data to .g7t and .gpx
          files. Previously the track link data was only saved in
          .gdb files.

Aug 26, 2009
          Placed a check for a line being too long in the reading of
          .csv files.  If a line that is more than 255 characters is
          read the rest of the file will be skipped.  A .csv file is
          a standard ASCII text file and must be terminated with a
          CRLF pair.  Terminating with a single LF or a CR will cause
          G7ToWin to fail to read the lines correctly and is not 
          allowed.

May 28, 2009
          Changed serial port timeout values for Magellan units. The
          timeout value is 2 seconds and the program will re-try
          five times.

April 4, 2009
          Extensive changes were made to the Edit a Waypoint dialog
          to facilitate using G7ToWin to read/write/create Garmin
          POI files.  See the helpfile for more info.

          Cleanup and bug fixes for the code written in the last few
          days.

April 3, 2009
          Added ability to edit a waypoints Street Address, City,
          State/Province, Country, Postal Code, and Telephone Number.
          This is primarily for use with .gpx files and the Garmin
          POI loader.

April 2, 2009
          Added a postMunge option to apply when reading waypoint
          duplicate.  This will add a '_mX' where X is a number
          that starts at '1' for the first duplicate and increments
          for each duplicate for that waypoint.  For example, if
          postMUNGE is selected and the three waypoints MYWPT,
          MYWPT, and MYWPT are read the three will become MYWPT,
          MYWPT_m1, and MYWPT_m2.

          Added the ability to read and write .csv files that are in
          Garmin POI format.  See the G7ToWin helpfile for more info.

Mar 30, 2009
          Fixed a problem reading a quoted field in a .csv file when
          that field contained a comma.  The comma ended the field
          and it should not have.

          Added the ability to read Address info from MapSource .gpx
          files and write the data to both .gpx and .g7t files.  The
          data in .g7t files is in a new continuation line: 'cE'
          and is this format:

          cE    Street Address|City|State or Province|Country|Postal Code|Telephone Number

          At this time there is no way to edit the address info
          with G7ToWin.

         
Mar 28, 2009
          Internal housekeeping.

Mar 7, 2009
          Added a command line option -web.  This option is used
          for internal web site housekeeping.  If you really wish to 
          see what it does execute G7ToWin -web >mm and then edit the
          file mm.

          Added a command line option -v to display the version and
          build time.

Mar 4, 2009
          Fixed a bug that caused a track created by a conversion
          from a route to output incorrectly to .PCX5 files.  Each
          track point would be output as the start of a new track.

Mar 1, 2009
          Modified the 'send to Google Maps' functions to use
          the default web browser and not specifically execute IE.

Feb 22, 2009
          Moved around some Waypoint List right-click menu items.

          Gamin has introduced two new waypoint display parameters:
          Image, Image & Name.  Garmin did not define what these
          are in the help file. MapSource will save these two new
          values into a .gdb file but will not save them to .gpx
          files.  When saving to .gpx they will be changed to 
          Symbol+Name.  When reading .gdb files G7ToWin will convert
          Image display mode to Symbol and Image&Name display mode
          to Symbol+Name.  If .gpx file writing is updated to include
          the two new display parameters then G7ToWin will also be
          updated.

Feb 6, 2009
          Added Cntl+G to send first selected waypoint to Google Maps
          from a waypoint list.

          Fixed a problem reading tracks from .gpx files written by
          gpstuner.

======================================================================
A.00.200f
Jan 24, 2009
          Minor change so that a .gpx file without an 'encoding' tag
          is assumed to NOT be in UTF-8 format.

Jan 18, 2009
          Minor change to bring the helpfile comments concerning
          UTF-8 and the code into agreement. If G7ToWin reads 
          data from a GPX file written in a format other than UTF-8 
          no conversion of data is made.  G7ToWin writes data in
          UTF-8 format and will convert any characters accoringly.

          This may or may not be what is desired so it is best
          to either not mix data sources or to carefully check
          GPX files written by G7ToWin to ensure the data is
          written in a desired manner.

Jan 14, 2009
          Fixed a small precision error in cut/paste of waypoint
          lat/long. The cut or copied value could be off by 1 in
          the 6th digit to the right of the decimal.

          Fixed an error that could cause the program to crash
          when deleting a record or multiple records from a
          list.

          Added support for saving .kml files for use with Google
          Earth.  Waypoints are placed in a folder named Waypoints
          and tracks are in a folder named Tracks.  Both Wapoints
          and Tracks are in a Document named for the file name.

          Each subtrack is a new track and has the name of the
          original track with a ' - X' added where X represents
          the subtrack. The point data consists of lat, long,
          altitude in meters.

          Waypoint data consists of the name, description or
          comment, and coordinants: lat,long,altitude in meters.

Nov 19, 2008
          Changed default .g7t file output version to 3.  Version
          three files require that track point names be output
          and reside in version 3 files.  However, the date time
          line is not required in version 3 files. The selection
          of which file version to use for output is now a drop
          down list and not radio buttons.

Nov 11, 2008
          Fixed a problem deleting a single waypoint from a route
          in a route list window.

          Some debug code was left into the route download code
          for Garmin mapping units and that caused route waypoint
          names to be replaced with the type of point.  Removed.

Nov 8, 2008
          .g7t files that were version 2 files but did not have
          the date line immediately following would cause G7ToWin
          to crash. Fixed.

Nov 4, 2008
          Added an item to the right click menu for the waypoint
          list and trackpoint list. This item will allow the first
          selected waypoint or trackpoint in the waypoint or 
          trackpoint list to be 'sent' to Google Maps.

          When this item is selected the program will attempt to
          find iexplore.exe and execute it with the proper URL
          to send the data to Google Maps.  If the program is unable
          to find iexplore.exe the menu selection is ignored, i.e.
          no error message is displayed.

          The items added are:
          Send First Selected Wpt To Google Maps
          Send First Selected Trackpoint to Google Maps

Oct 8, 2008 (same day)
          Local time zone offset can now be written to .gpx files
          by selecting 'Output Local Times' in File->Conviguration->
          General Tab->Text File Modifiers.

          Fixed a typo that caused processing of offset times to
          sometimes crash the program.

Oct 8, 2008
          Modified reading of .gpx files so that times encoded as

          <time>2008-05-16T18:47:52.000+hh:mm</time> and
          <time>2008-05-16T18:47:52.000-hh:mm</time> 

          where hh:mm is an offset from GMT are read.  The '+'
          indicates the local time zone is ahead of GMT and the '-'
          indicates the local time zone is behind GMT.  I am not sure
          if this is in violation of the .gpx schema which specifies
          GMT for the time element, but several programs 'out there'
          utilize the offset when they write .gpx files so I'm adding
          it to G7ToWin and G7ToCE.  G7ToWin and G7ToCE will continue
          to only write .gpx time elements in GMT using the format:

          <time>2008-05-16T18:47:52Z</time>.

Sept 29, 2008
          Fixed a bug in reading a waypoint's category from a .gpx
          file.

Sept 28, 2008
          Added .g7t and .csv to the file format that support track
          point names for read and write.  
          
          For this to be valid .g7t files MUST have the date the
          file was created as the first line after the Version
          line.  If the generation of the .g7t file (eg SeaClear)
          does not include the date the file was created as the
          first line after the Version line then track point names
          are not read.

Sept 27, 2008
          Added ability to read, display, and edit trackpoint
          names. GPX files are the only files supported for reading
          and writing trackpoint name data.

Sept 26, 2008
          Fixed a problem introduced during experimental conversion 
          of program to run under 64 bit OS.

          Added the ability to edit track point times.  The data
          input format must be followed exactly as minimal checking
          is performed.

          Changed the way Insert Track Element (accessed from
          the right click menu on the track list) operates.  See
          the helpfile for details.

Sept 10, 2008
          Modified reading .igc files to be in accordance with the
          latest IGC spec (through amendment 11).  This requires
          a rollover of the time element from the 23rd hour to the
          0th hour to result in the increment of the date by one
          day.  G7ToWin was originally written to the original spec
          which was not clear on the issue so the increment in the
          date was not performed.

Sept 6, 2008
          Extended support for umlauts and added lower case support
          to sending/receiving from Garmin units.  In the 
          configuration General Tab:

             File->Configuration->General tab

          If the item "Allow lwr case & chars >0x7F?" check box
          is checked it overrides the item 'Convert Garmin Wpt
          names?' to allow characters with a value > 0x7F and
          certain other values, including lower case characters,
          to be sent to the Garmin GPS.  See the helpfile for
          a full list of those characters below 0x80 that are
          allowed.

Sept 4, 2008
          Added support for byte values of 0x80-0x255 in the
          waypoint name, comment, or category.  At the present
          time this is only used with .gpx files which are
          output in UTF-8 which requires bytes with those vaules
          be encoded as two bytes.

Sept 2, 2008
          Forced a route read from an Ozi .rt2 file to never be
          assigned to route 0.

          If route 0 exists and the data is sent to an Ozi .rte
          file the route will be sent at route 'n' where 'n' is
          the next unused route.

          These changes were implemented because Ozi does not
          support route number 0.

          A bug in the Route Edit page was fixed. This bug could
          cause the last waypoint of a route to become trashed.

          Removed Visual Styles.  Using Visual Styles would cause
          the program to no longer support versions of Windows
          prior to XP.

May 26, 2008
          Fixed a bug which caused an empty temperature field in a
          .csv file to be read as 0 degrees C.

May 25, 2008
          Recompiled using visual styles.  That removes the annoying
          Beep bug when changing the selected item in a listbox under
          Vista.  This may cause problems in versions of Windows
          prior to XP SP2.

May 23, 2008
          Fixed a bug in reading .gdb version two files.  This was
          caused by a change in the way MapSource handles the file.
          This change was made sometime in the past--likely before
          .gdb version 3 was introduced but I didn't notice the
          change.

Nov 29, 2007
          If a GPX file contained a space before the = in a latitude
          or longitude, i.e. <wpt lat ="42.422326" the value would
          be read as zero.  Fixed.

Oct 18, 2007
          Added a Warning indication that will notify when a download
          or file read has resulted in duplicate waypoints.

          The checkbox is on the Configuration-General tab in the
          Reading Dups frame.  The Warn? box probably should not be
          checked in a configuration file used with a command line
          operation.

Sept 23, 2007
          Fixed a bug in reading gpx files that could result in anything
          from no errors to duplicated entries.

Sept 23, 2007
          Fixed a bug in the reading of waypoints from .gpx files when
          using the command line version of G7ToWin.

Sept 22, 2007
          Fixed a bug in reading routes from .gpx files.  This bug
          was introduced when the reading speed was increased.

Sept 19, 2007
          Increased the speed of reading .gpx files.

Aug 1, 2007
          Minor change to allow French spelling of month names
          to be read from the comment field of those Garmin
          GPS units that support the comment field and the French
          language.  The months in French are converted to English
          upon being read from the GPS.

          Changed program to force first route read from a MapTech
          route file (.rxf) to be route # 1.  This change was made
          due to user requests.

          Fixed a bug that sometimes caused G7ToWin to crash when
          reading .cup files.
         
May 6, 2007
          Events not handled properly on a command line download from
          a LEI unit.  Fixed.

Apr 24, 2007
          Fixed a problem sending data to SA4-SA9.  Selecting to not
          send names to Route 0 waypoints would also remove the names
          from regular waypoints.

Apr 23, 2007
          Fixed a problem reading the SP III as a default icon family.

Apr 22, 2007
          Fixed a problem reading .loc files.  Sometimes the type
          parameter was decoded incorrectly.

Apr 17, 2007
          Modified the way G7ToWin handles command line parametes.
          The configuration file pathname can now be specified.
          See the helpfile under 'Command Line Options' for more
          information.

Apr 14, 2007
          Added Temperature and Proximity distance to 'sortable'
          columns in the waypoint list.

          Previous to this version all proximity waypoints were
          sent to the gps whenever waypoints were sent using
          the 'Send Selected waypoints to' popup menu from the
          waypoint list.  With this release only selected waypoints 
          are sent.

Apr 10, 2007
          Fixed a bug in reading waypoint categories from the
          registry.

Apr 9, 2007
          Waypoint Categories can be loaded from or saved to the 
          registry in an area where MapSource will read and use
          the names.  This allows G7ToWin and MapSource to use
          the same categories.

          Waypoint Categories are now saved to the g7towin.ini file.

          If output file Version 1 is checked on the configuration
          tab and the output file type is .g7t then the Category
          line will not be written to the file.  ALL other aspects
          of a .g7t file remain unchanged.

Mar 25, 2007
          Fixed a problem saving a .igc file when neither of the two
          options to automatically name the file were checked.

Mar 17, 2007
          IGC files were being saved in the startup folder not in
          the Save IGC Folder.  Fixed.

Jan 10, 2007
          Fixed a problem reading/writing OziCE .rt2 files.

Jan 9, 2007
          Fixed a bug in reading lat/long in .gpx files.  Order of
          the elements is now not important.  Previously "lat"
          had to come first followed by "lon".

Jan 5, 2006
          Cleaned up USB routines and added to USB debug info.

Dec 2, 2006
          More work on Proximity waypoints.  See helpfile for a
          description of how Proximity waypoints are handled.

          More work on getting USB to work properly with Win98.

Nov 25, 2006
          Proximity waypoints weren't counted if a file was
          dropped onto the G7ToWin window or icon.  Fixed.

Nov 22, 2006
          Changed the way suffixes are handled in a file save.  If
          no suffix is input in the File Save input box then the file 
          name will have .g7t added as the suffix.  If a suffix 
          unknown to G7ToWin is used then the chosen file filter 
          suffix (Save as type:) is used.  
          
          Examples:

          If the filter suffix (Save as type:) is .gdb and

          fname to save            file saved
          myname                   myname.gdb
          myname.                  myname.gdb
          myname..                 myname..gdb
          myname.q                 myname.q.gdb
          myname.twx               myname.twx.gdb
          myname.g7t               myname.g7t

          If the filter chosen is All Files (*.*) then all of the
          extensions above will default to .g7t if the extension
          typed in isn't known to G7ToWin.

Nov 10, 2006
          G7ToWin looks for the string "MapSource" at the beginning
          of a .gdb file.  If the string does not exist the file can
          not be a MapSource.gdb file.  The comparison was case 
          sensitive.  Some programs output "Mapsource" as the string.
          G7ToWin could not read those files because the comparison
          failed.  This version changes the comparison to be case
          insensitive.

Oct 9, 2006
          Fixed a problem reading uncompressed .loc files.

Sep 8, 2006
          G7ToWin had the capability to decode a Garmin symbol from
          an OziExplorer waypoint description.  The symbol needed
          to be enclosed in semi-colons ";".  This use is no longer
          supported by G7ToWin.  If a user needs this capability please 
          let me know.

Aug 30, 2006
          Added build information to header in .gpx files.

Aug 29, 2006
          Fixed a problem with the VP and TP data in a .g7t track file.
          The values could be wrong if Distances weren't output to
          the file.
         
Aug 28, 2006
          Fixed a problem with the VP column in the output of track
          information to .csv files.

Aug 24, 2006
          Fixed a bug which could cause a program crash if too many
          files were read in and Monitor was checked.

Aug 23, 2006
          Recompiled so helpfile F1 subjects are in sync.

Aug 20, 2006
          Added to the 'Use REFERENCE Waypoint to' submenu.

Aug 17, 2006
          Added a cut/paste for waypoints.  The data format in the
          Windows Clipboard is documented in the helpfile.

Aug 12, 2006
          Fixed a time problem in reading .gpl files.  The GMT times
          in .gpl files were silently converted to local time but
          represented as GMT.

Aug 10, 2006
          Fixed a problem with track output to GPX files.

          Fixed a problem saving a route to a track.

July 29, 2006
          Fixed bounding box output in .gpx files.

July 20, 2006
          Added support for track data record D304 used in the Edge
          305.

April 25, 2006
          Fixed a typo which caused display download of supported
          units to fail.

April 12, 2006
          Added menuitem in Waypoint List to create a track from the
          selected waypoints.

          G7ToWin would fail if reading a .g7t file in which existed
          a waypoint with a caret (^) in the name.  Fixed.

April 11, 2006
          Tracks read from a .gdb file would not cycle colors when
          sent to SA.  Fixed.

March 30, 2006
          Minor changes to reading of .gpx files.  Previous version
          required waypoints come first followed by routes followed
          by tracks.  GPX files are now read three times, once
          looking for waypoints, once for routes and once for
          tracks.  This makes the order of the waypoints, routes,
          and tracks unimportant.

March 10, 2006
          Fixed a bug creating MapSource .gdb files introduced by a
          typo yesterday.

March 9, 2006
          Fixed a problem with the 'dirty bit' and saving proximity
          waypoints.

          Added build date and time information to Help->About and
          to the title bar.

March 8, 2006
          Added ability to preface route waypoint names with the
          number of the route.  This is set on the File->Configuration
          ->General tab.  The checkbox is cleared each time the program
          is started. This occurs at the time the route is read.

          Added the ability to set the number of routes handled by the
          program.  The number defaults to 100 (routes 0-99) and is
          set in the configuration "Folder Paths" tab.  If no routes
          have been defined the new setting takes place immediately. If
          routes are defined then the user is prompted to save the
          configuration and restart the program.

          NOTE:  As the number of routes increases the amount of
                 housekeeping increases at an exponential rate.  More
                 than 100 routes or so can cause the program to slow
                 down considerably.

======================================================================
A.00.200e
Feb 25, 2006
          Fixed a problem reading waypoint categories via the serial
          port.

          Fixed a problem reading OziExplorer route files when the
          Ozi time in the waypoint record is zero.

Feb 23, 2006
          Cosmetic changes and recompile.

Feb 18, 2006
          Added Product ID 292 to the list of Garmin units that
          support Lower case in waypoint data.  Product ID 292
          is at least the 76CSx and may be used for the 60Cx,
          60CSx, and 76Cx, also.

Feb 9, 2006
          Increased the allowable length of the comment field to
          50 characters.

          Created a class of Garmin units that allow lower case
          in Waypoint names and added the SP 7200 to the list.

Feb 5, 2006
          Changed text in two menu items to reflect the parameter
          WaypointNameLength added previously.

Feb 1, 2006
          Removed ability to remove duplicate waypoints based upon
          a name comparison of 6 or 10 characters.

          Added a waypoint name length parameter.  This parameter
          defaults to 20 and can be set on the File->Configuration->
          General tab.

          The waypoint name length parameter is used in a new menu
          item under Waypoints.  This menu entry will remove duplicate
          waypoints based upon a comparison involving the first X
          characters where X is set by the waypoint name length
          parameter.

          Under Waypoint list the 'right click' menu entry 'Select'
          has a new item used to select duplicates based upon a
          comparison of the waypoint names using the first X
          characters in the comparison.  X is set from the waypoint
          name length parameter.

          The waypoint name length parameter is also used in determining
          if waypoints are duplicates for sending waypoints to MapSource
          or writing waypoints to .gdb files.

Jan 26, 2006
          Waypoint categories were stored in the .ini file.  That
          is no longer the case.  Waypoint categories are stored
          in .g7t files and in .gpx files.  No other files have
          waypoint categories stored in them.

          Reading waypoints from a GPS that supports categories
          resets the category information in G7ToWin.  Sending
          waypoints to a GPS that supports waypoint categories
          will also send the categories to the GPS.

          NOTE: This has not been tested on Garmin units with
                a serial port.  I do not have access to a Garmin
                serial port GPS that supports categories.
    
Jan 21, 2006
          Added support for Transparent color tracks.  By default
          icons also support the tranparent color though I don't
          know of any units that support transparent colored icons.
Jan 12, 2006
          Minor bug fixes and code cleanup.
Jan 4, 2006
          Track point and Waypoint temperature is now saved to and 
          read from .csv files.

Jan 3, 2006
          Added ability to read simple TopoUSA .txt files.
Dec 29, 2005
          Switch to VS2005 C compiler caused problems with time
          counter.  Fixed.

          Added some error checking for improperly formatted lat/long
          in .g7t wpt/trk records.  This is not implemented for 
          versions of .g7t/.txt files prior to Version 2.
Dec 24, 2005
          Fixed a problem which caused the first waypoint read from
          to fail to save to a .g7t file.
Dec 21, 2005
          Fixed a bug that occurred when saving an Ozi.wpt file and
          the Icon set was a Magellan icon set.
Dec 19, 2005
          Changed Magellan download code to only report the first
          unknown data received.
Nov 25, 2005
          Modified icon names for the Magellan 330, Meridian, and
          SporTrak Pro to use the names presented to the user not
          the names as shown in the Thales specification.
Nov 23, 2005
          Magellan icon names will be written to .gpx files if a
          Magellan unit is selected.  Previously the Garmin
          equivalent was used.
Nov 22, 2005
          Fixed a problem which caused SporTrak Pro icon family to
          not be displayed.
Oct 28, 2005
          Fixed a problem in reading Ozi .wpt files with incomplete
          lines of data.
Oct 25, 2005
          Cosmetic changes only.
Oct 18, 2005
          Fixed a problem that could cause reading MapTech .rxf files 
          to fail.
Oct 17, 2005
          Altitudes from Magellan units was not displayed.  Fixed.
Oct 7, 2005
          If G7ToWin was started by dragging a file and dropping it on
          the G7ToWin icon the file could not be 'sent to' MapSource
          or to SA.  Fixed.

Oct 4, 2005
          Ozi files were output in WGS-84 even if a different external
          datum was selected.  Fixed.

Sept 26, 2005
          Added Legend (8Mb) with Product ID of 411 to list of devices
          that support display download.

Sept 21, 2005
          Changed the output of .gdb and .gpx files to NOT rename the
          first track to ACTIVE LOG if the box "Garmin Trk GPX Fmt?"
          is NOT checked on the configuration page.

Sept 5, 2005
          Changed the way duplicates are removed to keep the altitude
          of the waypoint that has a valid altitude.  If both
          waypoints have a valid altitude then other factors will
          decide which altitude to keep.

Aug 19, 2005
          Changed the way the program reacts after reading in a file.
          If waypoints are read then the waypoint list is displayed.
          If no waypoints are read but tracks are read then the track
          list is displayed.  If neither waypoints nor tracks are read
          but routes are read then the route tree is displayed.
          Proximity waypoints are counted as waypoints for the above.

Aug 15, 2005
          Fixed a problem with uploading proximity waypoints.

======================================================================
July 22, 2005
A.00.200c Minor bug fixes.

          Added ability to sort all tracks entered by date and time
          and create a single track from the sorted segments.

======================================================================
June 28, 2005
A.00.200b Added abilit to set Proximity Distance to that of the
          Reference waypoint.

======================================================================
June 5, 2005
A.00.200a Fixed a problem with altitudes in uploading Magellan track 
          points.

======================================================================
May 21, 2005
A.00.200  Added Category edit for Garmin Waypoint Category values.
          See File->Configuration->Waypoint Categories tab.

          Modified .gpx output to support Garmin Extensions for .gpx
          files as defined in MapSource 6.6.1 beta and above.
 
          Fixed a track naming problem when named tracks were output to
          .gpx output and the track did not have a name.

          Fixed a problem reading waypoint altitudes in .pcx5 files.

          Fixed a problem writing Ozi route names.

          Fixed a problem writing Ozi track names.

======================================================================
May 7, 2005
A.00.199f Set 'igc' to be the default file extension for 'Save IGC
          Track File' menu item.  The extension will automatically
          be added to the file name if an extension is not input
          and the file name does not end with a period '.'.
   
          Added 60C/CS (76C/CS) Icon support.

======================================================================
April 25, 2005
A.00.199e Program now reads/writes datum from/to Ozi files.  If the
          datum name written to the Ozi file has a trailing '*' 
          character then the datum does not exist within OziExplorer.

======================================================================
April 20, 2005
A.00.199d Output file selection for Ozi/Fugawi/PCX was inverted. Fixed.

======================================================================
April 20, 2005
A.00.199c Added track color to .gpx routines.

          Added 64 Custom waypoint symbols to MapSource symbol set.

          Changed Ozi .wpt, .plt, and .rte routines to support the
          0xD1 (209) character as a comma replacement for Ozi files.

======================================================================
March 4, 2005
A.00.199b Fixed a problem with the waypoints list.  On a sort the
          first selected item was not made visible.

          Fixed a problem with SA Text Size.  The value chosen on the
          configuration page was not remembered.

======================================================================
March 3, 2005
A.00.199a Fixed a problem which could cause a protection fault if
          G7ToWin was executed by double clicking on a file type
          associated with G7ToWin.

======================================================================
February 28, 2005
A.00.199  Added ability to send a Named track to MS, SA, GPS, File 
          from a track list.

======================================================================
February 25, 2005
A.00.198c Data containing duplicate waypoint names cannot be sent to
          MapSource or saved to .gdb files.  G7ToWin can read the
          resulting .gdb file but MapSource does not allow duplicate
          waypoint names and will report the file is invalid.  A check
          for duplicate waypoint names in the waypoint data to be sent
          to MS or .gdb is made and the user notified if such 
          duplicate data exists.

======================================================================
February 24, 2005
A.00.198b Added symbol name to waypoint list under symbol column. The
          name is the one that would be saved to a .gpx file.

======================================================================
February 21, 2005
A.00.198a Moved program folders from General configuration tab to a
          separate tab. Resized configuration tabs to fit when used on
          a 800x600 display.

          Fixed a problem reading routes from .gdb files.

          Added 'Save Selected Route to a Track' item to 'right click
          popup' for route lists.

          Revised helpfile to reflect the changes and added information
          to the helpfile.

          Changed the 'set waypoint time from nearest track point time'
          by adding the ability to ignore the minimum distance

======================================================================
February 14, 2005
A.00.198 Released only to a few beta testers.

======================================================================
February 13, 2005
A.00.197a Cleaned up a cosmetic issue with the startup directory.

======================================================================
February 9, 2005
A.00.197 Added the ability to show the VP value in track lists in
         Knots, Miles/hour, kilometers/hour, feet/second, or
         meters/second.

         Reorganized the configuration dialog into only two large 
         tabs.  The first is all 'general' options and the 2nd is 
         Street Atlas Options.

         Modified helpfile to show the new configuration tabs.

         Fixed a bug in reading MapSource files written in languages
         other than English.  The bug caused an immediate out of
         memory error.

         Added preliminary support for tracks in the Forerunner 301.
         This is not completed yet--download partially works, upload
         has not been addressed yet.

======================================================================
January 29, 2005
A.00.196 Fixed a missing menu item and a bug in sending some waypoints
         to MapSource.

======================================================================
January 29, 2005
A.00.195 Added the 221 symbols from MapSource to the allowable symbol
         set.  Named the new Icon 'family' MapSource.

         Changed the way waypoints created from track points are
         numbered.  Previously they were sequential up to 9999 where
         they started over.  Now the number in the waypoint name
         is the number of the track point within the track buffer.
         This value is now displayed in the track list.

         Added reading/writing of Waypoints, Tracks, and Routes 
         from/to MapSource .gdb files. See the helpfile under the
         index 'GDB files'.

         Added ability to edit proximity waypoints.  Any waypoint
         in the regular waypoint list that has a Proximity Distance
         value is deemed to be a proximity waypoint.  

         The proximity code has NOT been extensively tested.  The
         only GPS I have which supports prox waypoints is the 12CX
         which utilizes an old prox data format.  I'm depending on
         users for feedback as to bugs with the proximity code.

======================================================================
January 9, 2005
A.00.194 Fixed a problem which could cause USB uploads to fail.

         Added D110 to the allowable Proximity download data formats
         for Garmin units.

======================================================================
January 6, 2005
A.00.193 Changed header of .gpx files.  

         Added switch to chose between single <trk> for a track
         segment (Garmin's format) and multiple <trkseg> elements
         for multiple track segments.

======================================================================
November 29, 2004
A.00.192 Added a distance value to the DMS configurarion page which
         allows input of a separation distance in meters.  If the
         distance between two waypoints is less than or equal to this
         distance their positions are considered equal for purposes of
         deleting duplicate waypoints by position.

======================================================================
November 29, 2004
A.00.191 Fixed an obscure bug in removing duplicate waypoints.

======================================================================
November 24, 2004
A.00.190 Added some support for the Link item to waypoints.  This is
         the 'Link' item supported in MapSource.  The Link item is
         currently used with .gpx and .g7t files and ignored in all 
         other files supported by G7ToWin.

         Fixed a bug in reading IGC track files.

======================================================================
November 19, 2004
A.00.189 G7ToWin will now read/write all regular MapSource symbols
         to/from a GPX file.

======================================================================
November 18, 2004
A.00.188 Added a 'Browse Folder' button to each of the Folder 
         Preferences edit box.

======================================================================
November 17, 2004
A.00.187 Added the ability to view/change the program's Folder
         locations for Save, Save IGC, Open, Serial Debug, and the
         location of the HelpFile. See File-Configuration and select
         the SA Text Options/Folder Preferences tab.

======================================================================
November 15, 2004
A.00.186 Changed the method used to calculate the G security record.
         This will require that users of VALIG7To.exe and
         VALIG7ToWin.exe download new versions.

======================================================================
November 12, 2004
A.00.185 Garmin MapSource program, version 6.5.0 beta introduced the
         ability to read/write .gpx files.  G7ToWin will now send
         files to an executing MapSource using the same method used
         to send data to an executing Street Atlas Version 3-9.

         Numerous modifications to the saving of IGC tracks.  These
         changes are not complete nor are they extensively tested.
         Use at your own risk.  The changes are documented in the
         latest helpfile.

======================================================================
October 20, 2004
A.00.184 Various housekeeping modifications, i.e. changed the file
         open and save dialogs to allow resize.

         Added data protocols D109 and D110.  I do not have a unit
         which utilizes this waypoint format so the code has not
         been tested.

======================================================================
September 14, 2004
A.00.183 Modified track output to SAx (not SA3) files to allow tracks
         to be labelled.  If tracks are labelled then track segments
         may also be labelled.  The color and size of the text may
         also be labelled. The tracks are labelled using MapNotes and
         if read back in the mapnotes will be converted to waypoints.
         This may not be what is desired, so this addition is primarily
         for output to SA Files.

======================================================================
August 27, 2004
A.00.182 Reading .csv files now decode the altitude/depth properly.

======================================================================
August 27, 2004
A.00.181 .csv files now contain altitudes/depths in feet or meters
         depending upon the status of the setting on the configuration
         page.

         VistaC display download now supported.

======================================================================
August 18, 2004
A.00.180 Added G7ToWin's identifier (XGW) to A and L IGC records and
         cleaned up the output to IGC files.  For example only one
         HFDTE record is now output and a HFGPS record is now output.

         Corrected error in first/last track switch added in A.00.179.

======================================================================
August 17, 2004
A.00.179 Added display of a prompt if an attempt is made to save a
         .rt2 file but route 0 does not exist.

         In some instances when deleting duplicates the waypoint with
         the longest comment would be deleted.  Fixed -- the waypoint
         with the shortest comment is deleted.

         Added check box to Save IGC file dialog box that allows the
         user to chose whether to use the first valid track point time
         or the last valid track point time when generating an IGC
         compatible file name.  If no valid track point is found then
         the program uses the first track point as before.

         Changed the designation of COM ports from "COMx" where x is
         1 to 15 to "\\.\COMx".  The original form did not work for 
         values of x > 9.

======================================================================
June 7, 2004
A.00.178 Added to waypoint menu item.

======================================================================
June 4, 2004
A.00.177 Added a 'Save' button to route creation dialog box.  This
         allows multiple routes to be created at one time.  The Save
         button works exactly like the OK button but does not exit
         the dialog.

======================================================================
June 1, 2004
A.00.176 .csv files with data in the format

        W,Name,NDD MM.mmm,WDDD MM.mmm

      can be read.  UTM, D.dddddd, and now DD MM.mmmm formats are 
      supported for input from .csv files.  The program will not
      write data in DD MM.mmmm format.

======================================================================
April 26, 2004
A.00.175 Fixed a bug in reading OZI rte files.  This caused an improper
         route buffer full error message.

======================================================================
March 16, 2004
A.00.174 Added support for the GPSMAP 60C via either serial port or
         USB port.

         The serial port display download works.  The USB display
         download may occasionally retrieve bad data.  Usually a 2nd
         download will be correct.  I suspect this is a problem with
         the 60c, but without a unit to test I can't be sure.

======================================================================
February 17, 2004
A.00.173 Modified PCX5 output files so they are readable by G7ToWin.
         Previously only TTQVNew format was readable by the program.

======================================================================
February 17, 2004
A.00.172 Modified the way OziExplorer .plt files are written.
         Previously G7ToWin wrote a 0, 1, or 2 in Field 3 of a
         track point.  This signified a regular point (0), the
         beginning of a new segment (1) or the beginning of a new
         track (2).  Ozi only supports one track per file so the
         'new track' flag (2) was illegal.  If multiple tracks are
         sent to a single .plt file the 'new tracks' will be
         changed to 'new segment'.

======================================================================
February 14, 2004
A.00.171 Changed the number of routes/wpts to 50/50 for the Garmin
         GPS V.

         Modifed the reading of Ozi .plt files.  Ozi .plt files do not
         contain track names.  When Ozi .plt files are uploaded to
         some Garmin units the unnamed tracks are sent as a track with
         a blank name which can be confusing to users of the GPS.
         When the proram reads an Ozi .plt file the file is named
         FromOzi # where # is an integer starting at 1 and incrementing
         each time an Ozi .plt file is read.  The number is reset to 0
         each time G7ToWin is executed.

         Route->Create Dummy Route is always available.  This allows
         multiple 'dummy' route placeholders to be created. The name of
         the dummy route has been changed from DUMMY ROUTE to
         DRTExxx where xxx is an integer between 1 and 100 and 
         represents the number of dummy routes that have been created
         since the program was last executed.

======================================================================
February 12, 2004
A.00.170 Fixed a bug in track naming introduced in .169.

======================================================================
February 11, 2004
A.00.169 Changed the way the program handles forcing the name of a
         track to "ACTIVE LOG" if the first track being sent to a
         Garmin unit which supports named track logs isn't already
         named.  The program will now set the name to 'ACTIVE LOG' 
         only if a track log in the track data to be sent isn't
         already named 'ACTIVE LOG'.  This is NOT a 'rename' action, 
         it will occur only if the first track does not already have 
         a name.
        
======================================================================
February 10, 2004
A.00.168 Changed the output designator from a 'T' to a 'S' for .wiz
         trackpoints.  This change allows the track point to be used
         as a sounding designator.

======================================================================
January 31, 2004
A.00.167 Fixed a problem which caused the first <trkseg> to be missing
         from multiple tracks in .gpx output.

         Fixed a problem which did not allow the menu items to display
         properly in the waypoint list view window.

======================================================================
January 25, 2004
A.00.166 Changed the Type designator in .wiz files from a M to a S.
         This will allow depth readings to be processed.

======================================================================
January 23, 2004
A.00.165 Fixed a time conversion problem.

======================================================================
January 23, 2004
A.00.164 The program failed to read the time from the comment field on
         some Garmin GPS units.  Fixed.

======================================================================
January 18, 2004
A.00.163 Many changes/additions to the help file.  Context help via
         pressing F1 is now supported.

======================================================================
January 15, 2004
A.00.162 Enhancements to the Waypoint list window when waypoints are
         selected:
         
         1. The delete key will delete all selected waypoint when
            pressed with the waypoint list visible.

         2. If any waypoints are selected before the column is clicked
            to start the sort the same waypoints will be selected
            after the column sort and the list will be scrolled to
            ensure that the first selected waypoint in the list is
            visible.

         3. Typing CTRL-Z (control key and Z key at the same time) will
            send any selected waypoints to an executing Street Atlas 
            window.

        The definition of 'Prompt before program exit' check box has
        changed.  Previously if checked the program would always ask
        before exiting.  The new function is to ask only if the box
        is checked AND it appears as if GPS data has been modified but
        not saved.

======================================================================
January 13, 2004
A.00.161 Added the ability to download Geko (Product_ID=248) display.

======================================================================
January 5, 2004
A.00.160 Added the ability to read/write Geocache .loc files.  The .loc
         files must be standard ASCII, i.e. not compressed .loc files.
         The waypoint name, co-ords, and symbol (from the <type> tag) 
         are the only items decoded.

         .LOC files written by G7ToWin contains only name, coords,
         symbol and description and is uncompressed.

         Modified the Get Position copy to clipboard insert tabs
         between fields.

======================================================================
January 3, 2004
A.00.159 Changed the way route numbering is handled within the program.

         Route 0 will be reserved for use with Garmin units.  Routes
         downloaded from a LEI or Magellan unit will never be placed
         into route 0.  Data within the program's route 0 position will
         never be uploaded to a LEI or Magellan GPS.
 
         If routes are downloaded from a Garmin unit which supports 
         route 0 and route 0 exists in that unit then downloading 
         routes will place the Garmin route 0 into the program's 
         route 0 slot.  Downloading routes from a Garmin unit which 
         does not support numbered routes will never place a route 
         into route 0.

         The GPS Command Get Positon for Garmin units will now
         display the data in the current datum and display mode.
         The displayed text string is also copied to the clipboard
         and can be pasted into other programs.

======================================================================
January 1, 2004
A.00.158 Added .gpx input.  The routines are designed to read only
         the data written by the program.  Other sources will likely
         work, but no guarantees.

         Added a menu item to right clicked tracks.  The new menu
         item, Delete Duplicates in Selected Track, will delete any
         duplicates in the currently selected track(s).  Duplicates are
         defined as those with equal co-ordinants and adjacent to
         each other in sequence.  Only the first one is kept.

         Some Magellan units do not respond to the DELETE,ALL command.
         G7ToWin has been modified to first delete waypoints, tracks,
         and routes before sending the DELETE,ALL command.  This will
         ensure that at least waypoints, tracks, and routes are 
         deleted.

======================================================================
December 27, 2003
A.00.157 Added Nouvelle_Triangulation_Francaise datum to program.  Also
         added entry using the same parameters for NTF_France datum.

======================================================================
December 26, 2003
A.00.156 Unsupported Magellan Product_ID's are defaulted to Product_ID
         of 42, Magellan Marine.

         Magellan SporTrak route records were decoded incorrectly.
         this resulted in every other waypoint in the route being
         ignored.  Fixed.

======================================================================
December 25, 2003
A.00.155 Fixed a problem where the command GPS->Download All would
         fail with newer Magellan units.

         Fixed a problem which caused the Symbols for the 330, Meridian
         Sport.... to fail to appear.

======================================================================
December 24, 2003
A.00.154 Added initial support for the following units:

         Sportrak Map/Pro, Sportrak, FX 324, Meridian Color, FX 324
         Color, Sportrak Color, Sportrak Marine, Meridian Marine
         (2003).

         I do not have access to a Magellan unit which supports
         named routes so the units are all set as not supporting
         named routes.  If you have one of the above units and it
         supports named routes please create a serial debug file,
         download waypoints and then download routes and send the
         debug file to me.  I'll update G7ToWin so it knows the
         unit supports named routes.

======================================================================
December 18, 2003
A.00.153 Fixed a bug which caused .gpx altitudes to be output
         incorrectly.

======================================================================
December 18, 2003
A.00.152 Added the ability to save minimal GPX files which can contain
         waypoints, tracks, and routes.  The <sym> element is set
         from the names for symbols as given in the Garmin spec and
         is based upon the conversion of the input waypoint to the
         internal format and then converted to the Garmin waypoint
         name.  This is NOT the waypoint name as specified by any
         particular Garmin GPS unit, it is the general name for
         waypoints using that symbol number as stated in the Garmin
         Protocol specifications.

======================================================================
December 15, 2003
A.00.151 Found a couple of problems with the way the StreetPilot 2610
         handles Symbols.  The Horn symbol simply cannot be set on
         the 2610, nor can a waypoint with the Horn symbol be created
         by MapSource and sent to the 2610.  The 2610 immediately 
         converts it to the Waypoint symbol.

         The Heliport symbol can be successfully sent and received by
         G7ToWin, but not by MapSource for the 2610 sends what I (and
         apparently MapSource too) think is an illegal value for the
         Heliport symbol.  If the GPS is a 2610 G7ToWin will
         send/receive the value that the 2610 expects/sends and make
         the appropriate conversions internally.  This apparent error
         has been reported to Garmin and if they 'fix' the firmware in
         the 2610 the kludge for the Heliport symbol will be removed
         from G7ToWin.

======================================================================
December 14, 2003
A.00.150 Added StreetPilot 2610 Icons.

======================================================================
December 12, 2003
A.00.149 Changed the way USB is selected.  The COM port selection box
         in File->Configuration has a USB check box.  If selected the
         I/O will be directed to the Selected GPS.  At this time
         the only GPS family supporting USB and supported by G7ToWin
         is Garmin (SP2610) so the GPS Selection box is set to
         Garmin_USB which is the only selection.

======================================================================
December 9, 2003
A.00.148 Fixed a problem uploading routes to serial units.  Caused by
         removing one too many lines in the USB changes.

======================================================================
December 9, 2003
A.00.147 Fixed a problem with the SPIII display download.  This has
         not been checked out with versions prior to 2.50, but on
         SPIII units with version 2.5 installed the downloaded display
         color palette is now correct and the lower portion is not
         truncated.

         Added a checkbox to the File->Configuration General tab.
         This checkbox is named "Ignore Garmin route sizes on send"
         and if checked all routes and all route points will be sent
         to Garmin units.  On some units this can cause problems. I
         added the parameter because it is very difficult to keep up
         with all changes in these values for all Garmin units.  Use
         at your own risk!

======================================================================
December 7, 2003
A.00.146 Added support for Garmin devices which communicate via
         the USB port.  The USB functions have been tested on the
         StreetPilot 2610 but not on any other unit.

    NOTE:  The USB code is not fully debugged yet and currently uses
           syncronous access.  One result of syncronous access is G7ToWin
           will cease responding on a USB glitch or if the GPS ceases to
           respond.  The only recourse at this time is to use the Task
           Manager to terminate the program and restart.  If the lockup
           was caused by the 2610 it may be necessary to power cycle the
           GPS.
           
           If lockups become a large problem I will re-write the code
           to use asyncronous access.  It was easier to debug syncronous
           code and as it is working well for me I decided to release it
           for others to use (i.e.  test :-) outside of my systems.
           Lockups happen rarely (virtually never) on my WinXP system(s)
           and an old 600MHz Win2k system, but is currently untested on any
           other system.

         Fixed several minor bugs.  Likely introduced a few... :-)

======================================================================
October 13, 2003
A.00.145 Added Magellan SporTrak and SporTrak Pro to the list of 
         Magellan GPS units which support lower case waypoint names.

======================================================================
September 19, 2003
A.00.144 Modified read routine so that non existing alt/dpth values
         are set to 1e25.  Previously they could be as low as 3.0e24
         which is 'non existant' for most Garmin units, but not all.

         Changed number of route points/route for GPS76S to 125.
         Changed number of route points/route for GPS176/C to 254.

======================================================================
July 7, 2003
A.00.143 Magellan Meridian GPS upload does not convert waypoint 
         comments to uppercase.

======================================================================
June 17, 2003
A.00.142 Magellan Meridian GPS upload does not convert waypoint names
         to upper case, previously all Magellan waypoint names were
         converted to upper case.

======================================================================
May 14, 2003 
A.00.141 Added the ability to create waypoints from track points via
         right click on the track list.  Waypoints are created for
         each selected track point starting at W00000 and running
         to W99999 for each execution of the program.

======================================================================
May 12, 2003 
A.00.140 When posting Version A.0.139 an older version was used.  I
         am not sure how that happened, but .140 should correct the
         .wiz problems seen.

======================================================================
May 6, 2003 
A.00.139 A new output format has been added.  If "DepthWiz importable
         files *.wiz" is chosen for the output file the output will
         be in a format directly importable by DepthWiz's Data Builder
         Wizard.  G7ToWin will not import .wiz files.  Waypoints and
         trackpoints only in the .wiz file.

======================================================================
Apr 26, 2003 
A.00.138 c8 continuity records were read incorrectly when read from
         .txt files which had been written as Text File Version 2.
         Fixed.

======================================================================
Apr 23, 2003 
A.00.137 Ozi .plt files Version 2.1 were read incorrectly.  Fixed.

======================================================================
Apr 22, 2003 
A.00.136 Increased waypoints per route for Legend to 125.

A.00.135 Increased waypoints per route for Vista to 125.

======================================================================
Apr 12, 2003 
A.00.134 Track column headers were saved/restored to the .ini file
         incorrectly.  Fixed.

         Added detection of the 'd' key and the DEL key to the track
         list.  When the track list has focus and at least one track
         element is selected pressing the 'd' key will delete that
         element.  Pressing the DEL key will delete all tracks which
         have at least one element selected.  This action is the same
         as right clicking on the track list and choosing Delete
         Selected Track Elements or Delete Selected Tracks respectively.

======================================================================
Apr 5, 2003 
A.00.133 Changed supported routes from 20 to 50 for the StreetPilot III
         Changed the number of route points from 50 to 1200 for the
         StreetPilot III.

======================================================================
Mar 11, 2003 
A.00.132 Added waypoint comments to .cup files.  The comment is in
         the 'Description' column.

         Added two columns to track list:

           VP - velocity in meters per second from the previous track
                point.  This is segment independent.  INF indicates
                0 time between these two points.

           TP - Time in seconds from the previous track point.  This
                is segment independent.

         VP and TP are written to g7t track files but are not read in.

         Changed the R value used in Sinnott's formula for calculating
         distance to R= 6371.0 KM IAW:
         FAI Sporting Code, GENERAL SECTION, Glossary Page 2
         http://www.fai.org/sporting_code/scg.pdf

         The value of R is now saved in g7towin.ini.  It is named
         SinnotsRadius.  Editing g7towin.ini can change the value.

         Fixed a couple of bugs which caused proximity waypoints to
         fail.

         Fixed a problem with .www files where distances were not
         calculated correctly if the datum was set to anything other
         than WGS-84.

         Enabled the reading/writing of Proximity waypoints from/to
         .g7t files and downloading Proximity waypoints from Garmin
         GPS devices.  These waypoints cannot be listed or edited 
         with G7ToWin.  They can be edited in the .g7t file and
         subsequently reloaded to G7ToWin for upload to the GPS.

         Fixed track list column so Zone Easting and Northing are
         displayed when UTM is selected

         Modified .www and .ttt read/write routines to support UTM
         formatted data.

======================================================================
A.00.131 Internal release.
======================================================================
Jan 23, 2003 
A.00.130 Fixed a problem with icon order in the G76S.

======================================================================
Jan 14, 2003 
A.00.129 Added a new menu item to the track list.  Right clicking on
         the track list now has a menu item which allow the creation
         of a route from all tracks which have at least one point
         selected.  All of the point in each of the tracks will be 
         added to a route named by the user.  The waypoint will be
         named TTXXXX where XXXX is a number from 0000 to 9999.  This
         number rolls over to 0000 and also starts at 0000 each time
         the program starts.

======================================================================
Jan 8, 2003 
A.00.128 Fixed a sign error in reading PCX5 files.

======================================================================
Jan 7, 2003 
A.00.127 Changed the way Touratech QV files are read and written.
         Versions of Touratech QV prior to 2.51.37 used an internal
         mapping to store icon information in .wpt files.  Versions
         after 2.52.48 use the Garmin Symbol number.  Versions
         between these two are undefined as the format was under
         development.  If you are using a version of QV from 2.51.37
         to 2.51.48 you should update.

         Writing of either type is available by checking either
         TTQV (Old) for versions of QV prior to 2.52.49 or TTQV (New)
         for versions of QV 2.52.49 and later on the Configuration
         page.  These options are only available if Ozi/Fugawi
         output is not checked.

         NOTE:  The Touratech QV .wpt file is based upon the Garmin
                PCX5 file format.

                This info also applies to QV route files (.rte).

         Fixed a bug with G records in CE devices.  The ability to
         select a G record for output was not available.

         Fixed a sign error in Datum conversions.


======================================================================
Jan 2, 2003 
A.00.126 Modifed number of routes/route waypoints for GPS 72.

======================================================================
Dec 25, 2002
A.00.125 Added GPS 76S icons.  Added GPS 76S Icon family.  NOTE:  The
         76S returns the same value for the two bouys.  Therefor it
         is not possible to distinguish them when they are
         downloaded.  Garmin has not responded to my email about
         this problem.

         Removed the extra space before the DESCRIPTION field in PCX5
         waypoint files.

======================================================================
Nov 10, 2002
A.00.124 Fixed a problem reading the icon family from Ozi .wpt files.

         Added ability to read PCX5 files formated in 'U LAT LON DEG'
         mode.

======================================================================
Oct 22, 2002
A.00.123 Added the ability to read OziCE plot files version 2.0.

         Waypoints output to .csv files had an extra CRLF and ';' in
         one area.  Removed.

         Reading waypoints from or saving waypoints to an LEI unit
         in command line mode no longer prompt for the range of
         waypoints to transfer.  The values are taken from the values
         in the accessed g7towin.ini file.

======================================================================
Oct 9, 2002
A.00.122 The number of points in an eTrex Summit defaulted to 30.
         Fixed.

======================================================================
Sept 17, 2002
A.00.121 The number of route points in an eTrex route was defaulted to
         30.  It should have been set to 50.  Fixed.

======================================================================
August 22, 2002
A.00.120 Increased wpt comment length to 50 chars in .g7t/.txt files.
         
         Fixed a long standing bug which did not allow searching the
         waypoint list using the keyboard.  It now works as documented
         in the latest help file under Keyboard searches.

======================================================================
July 14, 2002
A.00.119 Added eTrex, Camo, and Summit Icons.  Venture, Legend, and
         Vista are the same as eMap.

======================================================================
July 11, 2002
A.00.118 Revised method used to save OziExplorer .wpt files to 
         preserve symbol information.

         Removed Ozi_to... buttons on Configuration Icon Property
         page.

======================================================================
July 9, 2002
A.00.117 Getting a position from a Garmin GPS, via GPS->Commands->Get
         Position, will create a waypoint.  The waypoint will be
         named PSNxxxx where xxxx is 0 to 9999 and is represented by
         a counter which starts at 0 when the program is started.
         If the counter exceeds 9999 it resets to 0.  This feature
         was implemented at the request of a user.

======================================================================
June 25, 2002
A.00.116  Changed coloring on the program's icon.

          Added ability to read/write OziExplorer CE Route2 files.
          These files have the suffix .rt2.  Route 0 is the only route
          that is read and route 0 is the only route written.  These
          files can contain routes with up to 500 waypoints.  It is
          up to the user to split the route if desired.

          IGC track pressure altitude now set to zero.  Previously
          it was the duplicate of the GNSS altitude.

======================================================================
June 14, 2002
A.00.115  Fixed a bug in the IGC short name generation routine.

======================================================================
June 9, 2002
A.00.114  Changed Garmin route send routine to support more than 20
          routes and more than 30 route waypoints.

          Cleaned up a baud rate startup problem for Garmin units.  
          This was introduced in version A.00.111.

======================================================================
May 18, 2002
A.00.113  Typo in SP3 Icons caused some to register improperly.  Fixed.

======================================================================
May 15, 2002
A.00.112  Beta 42 Magellan Waypoints and trackpoints from the Southern
          Hemisphere were read as if they were from the
          Northern Hemisphere.  Fixed

          Fixed a problem where LEI units wouldn't cycle the baud
          rate.  This was introduced several revisions ago during
          the Magellan implementation.

======================================================================
May 13, 2002
A.00.111  Minor cleanup in startup code.  Baud rate for Garmin wasn't
          defaulted properly if the file g7towin.ini did not exist.

======================================================================
May 8, 2002
A.00.110  Added Geocache and Geocache Found icons to eMap symbol set.
          Minor cleanup in startup code.  

======================================================================
April 27, 2002
A.00.109  General cosmetic bug fixes in the Magellan portions.

======================================================================
April 23, 2002
A.00.108 Attempting to read a non-exstant file could cause a program
         crash--fixed.

         Added Magellan upload/download support:  
            All known icons are supported, however, not all icon
            images are correct.  I used those I had access to
            which includes the 315 and the Map 330/Meridian icon
            set.  
            
            Tracks uploaded will have their altitude set to 0.  
            Uploaded track point times will start at 00:00:00 
            and increment 1 second for each track point
            uploaded.

         Modified PCX5 file output to support MapSource 4.07.  This
         means that MapSource 4.07 must be used to input PCX5 files,
         MapSource versions less than 4.07 will not import the
         file.  This also means that this version of G7ToWin will
         not read the symbols properly if the PCX5 .wpt file was
         written by an earlier version of G7ToWin.

         Added a function to delete duplicate waypoints based upon
         the wayoint names first 6 characters.  This will allow the
         file to be output to a MapSource PCX5 file.  The MapSource
         PCX5 import function supports only 6 char names and does
         not allow duplicate waypoints.

         Modified the IGC track file output function to output GPS
         model, hardware ID and software revision in the 'A' record.

======================================================================
March 29, 2002
A.00.107 Added an item to the popup menu on track lists.  This item,
         'Combined selected tracks into one' will create one track out
         of all selected track/track elements.  The first item in the
         list will be the start of the track.  The user will have to
         edit the first point to set values such as name, color, etc.

         Selecting a single element in a track segment selects the
         entire track segment.

         The option works on the first contiguous selecton.  For
         example if an element in track one, two and 5 is selected
         only track one and two will be combined and become track
         one.  The old track three will become track 2 and so on.

======================================================================
March 25, 2002
A.00.106 Fixed a typo which caused G7ToWin to set all altitude values
         read from OziExplorer plot files to 'not used'.

======================================================================
March 21, 2002
A.00.105 Old PCX5 files without comments on routes and without symbol
         information would cause a program crash. Fixed.

======================================================================
March 19, 2002
A.00.104 The command line startup string was being truncated and
         fully qualified pathnames had the file name stripped so
         command line output for fully qualified pathnames did not
         work.  Fixed.

         A typo in a conversion constant caused all UTM calculations
         to report erroneous data.  Fixed.

         Changed reading g7towin.ini to use SearchPath.  This means
         G7ToWin will search for g7towin.ini in the following 
         directories (in order):

         1. The directory from which the application loaded. 
         2. The current directory. 
         3. The Windows system directory.  Use the
            GetSystemDirectory function to get the path of
            this directory.


            NOTE:  Windows NT/2000/XP:  The name of this
                   directory is SYSTEM32.

            NOTE:  Windows NT/2000/XP:  The 16-bit Windows
                   system directory.  There is no function
                   that retrieves the path of this
                   directory, but it is searched.  The name
                   of this directory is SYSTEM.

         4. The Windows directory.  Use the GetWindowsDirectory
            function to get the path of this directory.

         5. The directories that are listed in the PATH
            environment variable.

         If g7towin.ini is not found defaults will be used for all
         parameters.

         On initial startup StatusBar panel #3 will hold the path
         where the program found g7towin.ini.

         If G7ToWin.ini is written out, it will be will be written out
         to the loation from which it was read.

======================================================================
March 14, 2002
A.00.103 Changed the way G7ToWin locates the directory from which it was
         executed.  Previous versions used the 'CurrentDirectory'
         and attempted to read g7towin.ini from that directory.  This
         will fail if G7ToWin is executed from a command prompt. The
         command prompt will reset the CurrentDirectory to the directory
         at the time the G7ToWin command is executed.

         If G7ToWin is started from a command line G7ToWin can
         usually detect this.  A search is peformed using
         SearchPath.  The first place SearchPath looks is the
         the directory from which the application loaded.
         Therefore G7ToWin will find the .ini file there if it
         exists.  If the g7towin.ini file is not found in the
         application startup directory then the search halts and
         reading of g7towin.ini is skipped.

======================================================================
March 9, 2002
A.00.102 If file suffix .g7t is associated with G7ToWin then double
         clicking on a .g7t file will execute g7towin and the file
         will be read in.  If waypoints are read in they will be
         listed.  If no waypoints are read in but tracks are read
         in they will be listed.  If neither waypoints nor track
         points are read in but events are read in they will be
         listed.

======================================================================
March 2, 2002
A.00.101 Added 'G' security record capability to .igc file output.

         Added selection of IGC long file name format or IGC short
         file name format.

         Wrote two validation programs: VALIG7To.exe for MSDOS only
         and VALIG7ToWin.exe for windows programs.  Both are command
         line programs which scan an igc file written by G7ToWin or
         G7ToCE and determine if the G record is valid.

         See the helpfile for more detail.

         Added the waypoint reference distance to the 'C' continuation
         record.  The distance units is added to the value and appears
         the same as the distance units for the reference waypoint in
         the waypoint list:

cC    1e25|1e25|FF|00|00|00|00|00|00|FF|FF|FF|FF|FF|FF|FF|FF|FF|FF|FF|FF|80.225 S mi

         Added the reference distance, as a column, to the .csv file.
         Added the units to the column following the ref dist.

         NOTE: The reference distance is NOT read when a .g7t or .csv
               file is read.  The value is ignored when reading either
               of those file types.  The units are in the same units
               as the waypoint list and can be set on the configuration
               page. These values will only be valid when a valid
               reference waypoint has been set.

======================================================================
February 27, 2002
A.00.100 The last revision, A.00.99, has a typo which can cause *all*
         waypoints uploaded to have garbled latitude.  If you have
         .99 on your system immediately remove it!  The typo is
         corrected in this version.

======================================================================
February 23, 2002
A.00.99 Added file type .g7t.  This is a text file much the same as
        the old .txt files.  The difference is that continuation lines
        are always output and the continuation lines are re-defined.
        The original .txt format is still supported.  In the file
        Open and File Save As dialogs the .txt file is at the bottom
        of the list.  The old .txt file is fixed and will be phased
        out.
        
        For .g7t output:
        
        Continuation lines c1-c8 are not used in .g7t files.
        Three new continuation lines have been defined.  These
        three continuation lines will always be written to .g7t
        files when a waypoint is written.

        Note: All values are delimited by '|' character.  Therefore
        the '|' cannot be used in waypoints.

  0123456
  cA    WaypointName, StreetPilotLnk_ident, name, city, state, cc
  cB    facility, addr, cross_road, datatype
  cC    altitude, depth, wpt_class, 18 class bytes in hex 

  cA    001|||||
  cB    |||0
  cC    79.193726|1e25|00|00|00|00|00|00|00|FF|FF|FF|FF|FF|FF|FF|FF|FF|FF|FF|FF

======================================================================
February 16, 2002
A.00.98 Fixed a problem with writing PCX5 route files.  On input the
        first character of the route name would be stripped.

        Fixed a problem with Via's in editing route 0.  The Via check
        box was not properly displayed nor was the via value saved
        correctly.

======================================================================
February 14, 2002
A.00.97 Added read of PCX5 file support.  Changed the output of PCX5 files
        to support TTQV.  If the General Configuration tab has the 'PCX
        Wpt len 6 chrs' box checked then output is assumed to be going
        to a PCX5 file which will be imported by MapSource.  Names are
        truncated to 6 chars and the symbol set is chosen to match
        MapSource.  If the box is not checked then output is assumed to
        be going to a PCX5 file which will imported by TOURATECH QV
        (www.ttqv.com).

        On input of a .wpt or .rte file, when the Ozi/Fugawi box is
        NOT checked and the .wpt or .rte file is assumed to be a
        PCX5 file, the 'I' record is searched for the substring
        'Touratech QV'.  If it is found the file is assumed to be
        written by/for Touratech QV and the symbols are converted
        accordingly.  If the substring is not found the file is
        assumed to be in MapSource format and the symbols are
        converted accordingly.  The waypoint name is never truncated
        on input.

        NOTE:  The 'PCX Wpt len 6 chrs' check box is not visible when
               the 'Output is Ozi/Fugawi' box is checked.

======================================================================
January 30, 2002
A.00.96 Changed compiler back to VB.NET C++ unmanaged.  The changes in
        the compiler were made to track down a memory allocation bug
        in my code which was caught by the C++.NET debugger but was
        completely ignored by the Visual Studio 6.0 C++ debugger.
        The only time the bug would ever be seen in normal use is if
        all 100 tracks were filled and then it was not likely to
        cause a problem.

        Added ability to read from a GPS or write to a GPS on
        the command line.  On output to GPS all data currently
        read in will be sent.

            G7ToWin e:\waypoints\MyWpts.txt,w,GPS

        will read in the data in the file
        e:\waypoints\MyWpts.txt and write all data found to the
        GPS connected to the current COM port as selected in the
        .ini file.

        On input from a GPS things are a bit different.  Each
        character after the GPS is examined.  For each character
        encountered the associated data is read in.  For example

            G7ToWin GPSarrtew,,e:\waypoints\MyWpts.txt

        will download all data from the GPS followed by the
        routes twice followed by the tracks followed by the
        events followed by the waypoints.  All data will be sent
        to the file e:\waypoints\MyWpts.txt.  Filtering of
        duplicate records on input will be determined by the
        configuration parameters in the .ini file.  Of course,
        events will not be read in if the connected unit is a
        Garmin :-)

======================================================================
January 26, 2002
A.00.95 Changed compiler back to VS 6.0 C compiler.

        Added Street Pilot III icons to icon family.

======================================================================
January 22, 2002
A.00.94 Changed compiler to VS.NET C compiler.

        Saving .txt files now save the waypoint and track altitude and
        depth information in the units (feet or meters) selected by
        the File-Configuration Altitude/Depth selection radio buttons.
        This required the addition of a header line in the .txt file
        which defines the units used in the file.  If this line is
        missing then Meters is assumed.  The added line is one of two:

            A Meters Altitude/Depth units for this file
            A Feet Altitude/Depth units for this file

        The first three characters define the line.  The phrase 
        'Altitude/Depth units for this file' is descriptive only.

======================================================================
January 11, 2002
A.00.93 Updated copyright info to reflect 2002.

        COMMAND LINE ARGUMENTS:

        Several users have asked for a version of g7towin which will
        convert files without user intervention.  Others have asked
        for a version which will load a file on startup and display
        the list window.

        I have tried to accomodate the users by allowing g7towin to
        have command line parameters in this version. The format
        is:

        g7towin param1,param2,param3

        If param1 exists it is assumed to be a file pathname.  That
        file will be opened and read on startup.

        param2 can be:
            W or w  - list waypoints if they are present
            T or t  - list tracks if they are present
            R or r  - list routes if they are present
            E or e  - list events if they are present

        If param3 is present it is assumed to be a file name with the
        proper suffix, i.e. .txt, .csv, .www, etc.  The data read in
        from param1 will be written to the file specified in param3
        and the program will *immediately* exit.

        Error checking is NOT performed.  If an output file is given
        in param3 the data will overwrite.  For example, if you
        execute g7towin kkk.txt,T,myfile.txt and kkk.txt does not
        exist then the file myfile.txt will be cleared.

======================================================================
December 1, 2001
A.00.92 Changed about dialog to point to new web address.

======================================================================
November 16, 2001
A.00.91 PCX5 waypoint file output has been changed to limit the
        waypoint name to 6 characters and to more accurately map the
        waypoint symbol to the set used by MapSource.

======================================================================
November 14, 2001
A.00.90 Fixed a UTM display bug introduced in last version.

======================================================================
November 7, 2001
A.00.89 Dropped a bit in downloading some displays.  This could cause
        a program crash.  Fixed.

======================================================================
November 6, 2001
A.00.88 More color matching for 176C bitmap download.

        Monitor function:
        Added ability to resave column names read in via the g7towin.ini
        file rather than the new column names which might be read in
        via .mlp files.  This allows a 'default' set of column names
        to be held in the .ini file while new column names can be
        sent to the .mlp file.

======================================================================
October 29, 2001
A.00.87 Changed the method by which the lat/lon values are displayed in
        listviews (waypoints, tracks, events).

        Fixed problem reading MapTech routes which occured after a
        Clear All was executed and the next route read had the same
        name as the last route read before the clear all.

======================================================================
October 26, 2001
A.00.86 Fixed a bug introduced in .85 which caused line index errors
        on some bitmaps.

======================================================================
October 25, 2001
A.00.85 Added download of GPS176C bitmap.

======================================================================
October 25, 2001
A.00.84 Added download of GPS176 bitmap.

======================================================================
October 11, 2001
A.00.83 Added save of the .www column names to .mlp files.  The column
        names are also read when the .mlp file is read.

        Modified the reading of .csv files so that columns are
        defaulted if they are missing.  Prior versions crashed if
        certain columns were missing.

======================================================================
October 9, 2001
A.00.82 Did some cleanup in the processing of files dropped onto
        G7ToWin.

        Cleaned up a few errors in reading MapTech track files.  One
        of the errors resulted in the loss of the track names.

======================================================================
October 5, 2001
A.00.81 Tracks sent to some Garmin units must have a name or the track
        upload is ignored.  If G7ToWin attempts to send an unnamed
        track to a unit which supports track data record D301 and
        the track is not named then the name is set to ACTIVE LOG.
        This happens only on the first point of the first track
        uploaded.  Any subsequent unnamed tracks during the upload
        will not be named.

        Reading routes from a file where the route numbers are
        not unique is supposed to convert the non-unique route
        number to the next unused route number.  This code was
        commented out during a debug session sometime in the
        past.  It is now restored and duplicate route numbers
        should not cause the program to make a long route out of
        the non-unique routes.

======================================================================
August 15, 2001
A.00.80 MapTech files were not being saved correctly after the first
        one was saved each session.  Fixed.

        Fixed a problem with output of PCX5 tracks files.  The year
        was improperly written as ' 1' rather than '01'.

        Input selection suffix was improper between .txt and .clg.
        Fixed.

======================================================================
August 7, 2001
A.00.79 Added support for .cup files which are read/written by the
        Glider program SeeYou.

======================================================================
August 3, 2001
A.00.78 Added StreetPilot which returns a Product ID of 132 to the
        list of those allowed to download display.

        Added the ability to project and create a waypoint using
        a selected waypoint in the waypoint list as the base.
        This projection is based upon either a great circle
        projection or a dead reckoning projection using the
        International Spheroid eccentricity which is 0.08199188998.

======================================================================
July 23, 2001
A.00.77 Reading .csv files with a Z offset other than 0.000 would 
        result in the offset being applied twice.  Fixed.

======================================================================
July 21, 2001
A.00.76 Modified reading of .www and .ttt files to support old style
        and style files automatically.

======================================================================
July 19, 2001
A.00.75 Fixed an error in reading .www files, and in reading .ttt
        files.

======================================================================
July 16, 2001
A.00.74 If the Monitor box was checked the default file type no longer
        functioned correctly for file open or file save.  Fixed.

======================================================================
July 16, 2001
A.00.73 Added a right click menu item to the Waypoint, Track, and
        Event list which allows returning the order of the column to
        the state existing when the g7towin.ini file was last read
        or written.

        If the order of the columns was changed and then a right click
        menu item was chosen the order would revert to that before
        the list was created.  Fixed.

======================================================================
July 14, 2001
A.00.72 The order of the column headers in Waypoint lists, Track lists
        and Event lists can now be changed by drag and drop.  The new
        order is saved to the .ini file when that file is saved.  A
        new right click item has been added to restore the default
        column order.

======================================================================
July 12, 2001
A.00.71 Changed messages from GPS indicating "No xxx Records to send"
        to "GPS: No xxx secords to send". Removed the separate
        message "GPS: No Route secords to send".

        Added support for MapTech export files .RXF, .TXF, and .MXF
        for Routes, Tracks and Waypoints respectively.

        Added display download for the GPS 12Map.

======================================================================
July 7, 2001
A.00.70 Uploading tracks to the GPS from a right click on the track
        list window did not work.  Fixed.

        Right click on a route waypoint did not bring up the dialog
        box in the correct location.  Fixed.

        Misc. sub-menu cleanup.

======================================================================
July 7, 2001
A.00.69 When selecting which items to send to a text file from
        File->Save As with 'Prompt for save items' checked the program
        failed to save waypoints not used in routes correctly.  Fixed.
        Note, the decision as to whether a waypoint is used in a route
        is based upon a comparison of waypoint ID's and not on the
        waypoint names.

======================================================================
July 5, 2001
A.00.68 Changed Max route number from 99 to 100 to support Ozi .rte
        files.

======================================================================
July 5, 2001
A.00.67 Added Datum conversion to .www & .ttt files for input and
        output.

======================================================================
July 5, 2001
A.00.66 Changed many monitoring functions.

======================================================================
July 1, 2001
A.00.65 Added GPS-V display download.

======================================================================
June 28, 2001
A.00.64 Added back in a source line deleted by mistake.  This error
        resulted in Tracks->Download not working while
        GPS->Download->Tracks did work.

======================================================================
June 26, 2001
A.00.63 Changed output of the waypoint name in PCX 5 waypoints.  The
        name cannot be longer than 6 characters or MapSource will
        error on import.

======================================================================
June 25, 2001
A.00.62 Changed output of the date in PCX 5 waypoints.

======================================================================
June 18, 2001
A.00.61 If the waypoint edit or track edit was active and UTM was
        the DMS Mode then a loss of focus on the Northing parameter
        could cause a program crash.  At the least, the data was
        corrupted.  This bug has  been in the program from the first
        release and I just happened it come across it today....fixed.

======================================================================
June 17, 2001
A.00.60 Fixed display problem generated in .59.

======================================================================
June 15, 2001
A.00.59 Fixed selection of Ozi/Fugawi output check box.  It didn't
        take effect until the program was exited and re-started.

        Began modifying the source files to enable them to compile
        under Embedded VC++ 3.0 for use on a Pocket PC.  A few problems
        are likely to show up.

======================================================================
June 5, 2001
A.00.58 Added display download for GPSMAP76.
        Added version number display to titlebar.

======================================================================
June 5, 2001
A.00.57 Fixed a bug introduced in A.00.56.  This bug caused several
        download operations from the GPS to exit without doing
        anything.

======================================================================
June 4, 2001
A.00.56 Added route output to PCX5 files. (*.rte).

        Added 4 columns to track output in .txt files.  The 4 colunns
        are Dist units: NM, SM, kM, M, ft.  This column defines the
        distance units of the following 3 columns.  The columns are,
        in order:

        distance from the previous track point to this point
        distance from start of the current track segment to this point
        distance from the start of the track log to this point

        These 4 columns are ignored when reading the file.

======================================================================
June 2, 2001
A.00.55 Continued implementation of PCX5 output.  Currently output is
        limited to version 2.08.  I do not have documentation or 
        samples for PCX5 version 2.09.

        Fixed bug introduced when modifying the download routines in
        version A.00.54.

======================================================================
June 1, 2001
A.00.54 Modified the download routines to operate properly when the
        connected GPS doesn't return the number of records to send
        if it doesn't have any to send.  As far as I know none of
        the Garmin units do this, but GPilotS in emulation mode does
        exhibit this behavior.  G7ToWin will now set the record
        count to 0 before asking for the number of records.

        Began implementing the ability to save files in PCX5
        format.  Waypoints are implemented but not routes,
        tracks, or proximity waypoints.  It is definitely beta
        at this time as I don't have PCX5 to test my output.

        To implement output to PCX5 remove the check from the
        box labeled "Output is Ozi/Fugawi" on the general
        configuration page.

        I have no intention of implementing the ability to read
        PCX5 files.

======================================================================
May 29, 2001
A.00.53 Changed the number of files which could be selected on the
        File->Open dialog box from 20 to 256.  The total length of
        all file names chosen must be less than 15000.  This
        calculation does not include the path, just the filename.

        If an attempt was made to send data to an open SA window
        and the user had another window with Street Atlas in the
        title, such as having the explorer pointing at

        C:\program files\Street Atlas USA xxx then the explorer

        window would be used which fails.  The program now looks
        for " Street Atlas USA".  The leading space will reduce
        the number of spurious windows which may be found.

======================================================================
May 20, 2001
A.00.52 Added a check box labelled 'Activate mlp conversion' to the
        Monitor Lookup Parameters dialog box.  
        
        If this box is checked then the data for the
        Organism_Observer is taken from the .mlp file which was
        read in.  If no file has been read in or the data for
        that object is blank then MISSING will be output to .www
        files for the Organism_Object column.

        If this box is not checked the the data for the
        Organism_Object column will be taken from the data read
        from the .www file.  If the data is not from a .www file
        or the data for the Organism_Object column was blank
        then MISSING will be output.

======================================================================
May 19, 2001
A.00.51 Changed the method of picking the COM port and the port speed
        to allow COM1-COM16.

        G7ToWin could not handle multiple zero length strings in
        the ID string.  Multiple zero length strings are not sent
        by any Garmin units, but they were sent by GPilotS in host
        mode.  Fixed.

======================================================================
May 15, 2001
A.00.50 Some Garmin GPS units failed to download the almanac fully.
        The current code has been tested with the 12CX, GPSIII+, and
        eMap.  If the download almanac command times out after the
        first satellite is downloaded please send me the product ID
        of your unit.  The command GPS->Get GPS ID will display the
        product ID.

======================================================================
May 12, 2001
A.00.49 Fixed a typo in A.00.48 which caused D109 records to fail in
        some circumstances.

======================================================================
May 11, 2001
A.00.48 Waypoints *created* with G7ToWin defaulted to D108 which
        caused upload problems when the destination GPS used D109
        for waypoints. Fixed.

======================================================================
May 11, 2001
A.00.47 Added a check box to the General configuration page.  This box
        is labelled Display Local Time.  If this box is checked then
        times displayed for waypoints and tracks in their respective
        listviews is converted to local time.  If this box is
        cleared then the times displayed in the listview window is
        UTC.  This has no effect on the output to .txt and .csv
        files.  That is still controlled by the Output Local Time
        parameter.

======================================================================
May 7, 2001
A.00.46  Added display download for the GPS12 series except for the
         12CX which apparently doesn't support display download.

======================================================================
May 3, 2001
A.00.45  Fixed a buffer overwrite bug.  This caused various strange
         failures by allowing a write outside of the bounds of the
         buffer.

======================================================================
April 27, 2001
A.00.44  Fixed a bug reading plot trail points in .csv files.

======================================================================
April 25, 2001
A.00.43  Added "S-42" datum listings for
         Albania, Czechoslovakia, Hungary, Latvia, Poland, and Romania.

         All datum data was taken from:

         http://www.joe.mehaffey.com/warsaw.txt

======================================================================
April 23, 2001
A.00.42  Added display download for the Venture.

======================================================================
April 11, 2001
A.00.41  Added display download for the Vista.

======================================================================
April 5, 2001
A.00.40  Legend display is now shown vertically.

         Fixed an upload bug for waypoint record D109.

         Added output to a .txt file to show where the input came from
         if the Monitor box is checked.  This only applies to input
         from .txt files, .www files, .ttt files and Garmin GPS units.
         The values used are reset if Clear all is executed or if
         Clear waypoints is executed and the number of track points
         is 0 or if Clear Tracks is executed and the number of waypoints
         is 0.

======================================================================
March 28, 2001
A.00.39  Added support for download of Legend display.

======================================================================
March 28, 2001
A.00.38  Added support for StreetPilot III.

         If Over Ride is not checked and the input is from a text
         file the Monitor Observer for each record is set to
         'MISSING'.  If the Over Ride box is checked the 
         Monitor Observer for each record is set to the value
         of Monitor Observer for all inputs as before.

======================================================================
March 19, 2001
A.00.37  Track data are now sorted by time prior to output to 
         .ttt files.

         The Monitor_Observer parameter is attached to waypoint
         and track records when read from Garmin GPS units.

         Each record output to .www or .ttt files will have the
         observer associated with the record output with that
         record.
         
         Previously the current value of the Monitor_Observer
         was attached to each record read from any input, even
         .www and .ttt files.  This caused each record's
         Monitor_Observer value to be overwritten by the current
         setting when the input was .www or .ttt.

         Added a check box named 'Over Ride' in the Data 
         configuration page (accessed from File->Configuration
         when 'Monitor' is checked and Data is pressed).  When
         checked the Monitor_Observer value for each record
         input will be set to the current Monitor_Observer value
         irregardless of the source of the input.  The Over
         Ride value is saved in the g7towin.ini file.

         Corrected an error which caused the Monitor_Observer to
         be lost when input was .www files.

         Changed the TrackPointName column to Txxxx_yyyyy.

         T0001_00001......

======================================================================
March 18, 2001
A.00.36  Added a new column to .ttt file output.  The first column is
         now named TrackPointName.  This allows placing a 'name' on
         a track.  The format of the name is Txxxxx_yyyyy where
         xxxxx is the xxxxxth day found in the track list and the
         yyyyy is the yyyyyth track entry for day xxxxx.  This
         requires that track points be in date/time order.  If your
         track file has a point from day one followed by a point from
         day two followed by a point from day 1 the program will
         output
         
         T00001_00001.....
         T00002_00001.....
         T00003_00001.....

         If a 'default_icon color' is found in any input file then
         it is converted to the value of the 'icon default color
         mapping' in the File->Configuration->Icon property tab.
         Previous versions converted only waypoint icon color data
         read from the GPS.

         .txt files written via the File->Save As and chosing the
         .www file suffix will now have the name of the .mlp file
         used to convert data saved in the .txt file as a comment.

======================================================================
March 6, 2001
A.00.35  Added gridlines to the Track list and Waypoint list.

======================================================================
March 5, 2001
A.00.34  Modified DMS output routine in an attempt to eliminate errors
         like 'E121 33 00.00' being displayed as 'E121 32 60.00'.
         New help file is available.

======================================================================
February 24, 2001
A.00.33  Fugawi waypoint files were not being closed after being
         written.  Fixed

======================================================================
February 13, 2001
A.00.32  Added Sum_Sequential_Distance column to .ttt output files and
         to .www files. The Sum_Sequential_Distance column is the sum
         of the last Sum_Sequential_Distance column and the current
         Sequential_Distance column.

======================================================================
February 11, 2001
A.00.31  Added Sequential_distance column to .ttt output files.

======================================================================
January 27, 2001
A.00.30  Added waypoint output in RACE 2000 file format.  This is for
         waypoints only and is accessed by using file suffix .rce.
         The format of the file is described in the help system.

======================================================================
January 17, 2001
A.00.29  Added functions to the IGC save header file.  The pilot box
         is now a drop down list.  When the program is started it
         looks for a file named GliderPilots.txt in the startup 
         directory.  If the file is found it is used to populate
         the drop down and text boxes in the IGC Save Header dialog
         box.

         The format of the file is as follows

; this is a comment
# so is this
Pilots Name | Contest ID (3 chars max) | Glider Type  | Glider ID | Site | Class

        The character '|' must be used to separate each item though a null
        entry ( Contest ID||Glider ID) is ok.  Spaces before each field
        and after each field are removed.

        Up to 5000 pilots can be in the database, though more than a
        few hundred can slow down the program a bit when building the
        dropdown box.

        The entries are sorted, so entering the pilots name as

        lastname, firstname

        is suggested. 

        On startup the program will attempt to load the data from the
        data supplied by the GliderPilots text file.  The pilot's
        name comes from the g7towin.ini file.  If a matching
        name is not found in GliderPilots.txt file then the last used
        data from g7towin.ini is used to fill the text boxes. 

        Typing new data into any of the text boxes or the pilot drop
        down edit box will cause that data too be used in writing the
        file.  However, this program does not update the GliderPilots.txt
        file.  That update must be done by the user.

======================================================================
January 11, 2001
A.00.28  Processing a waypoint record with only a waypoint name can
         cause a problem.

         Reading track points from a .csv file did not properly
         convert the datum from the datum named in the file to 
         the internal datum.

======================================================================
December 11, 2000
A.00.27  Changed 'Like Distance' to be 0.0 on undefined rather than
         -1.0 meters as it previously was.  By request of those who
         actively use the 'Like Distance' calculation.

======================================================================
December 1, 2000
A.00.26  Made Lat/Lon input uppercase only.  This has an effect on
         UTM only.  Entering the zone character in lowercase resulted
         did not work properly.

======================================================================
November 27, 2000
A.00.25  Fixed a sign error in UTM conversion.  It caused the Northing
         in southern latitudes to be incorrect.

======================================================================
October 26, 2000
A.00.24  Reading .csv files did not read routes correctly.

======================================================================
October 20, 2000
A.00.23  Added double quotes around waypoint comments in .csv file
         output when those comments contain one or more comma
         characters.  Did the same for route names.

======================================================================
October 8, 2000
A.00.22  Changed the precision of displayed altitude and depth in the
         waypoint/track edit and create dialog box.  In previous
         versions the precision was rounded to .x.  It is now rounded
         to .xxx.

         Added column names to route and track .csv files.

======================================================================
October 2, 2000
A.00.21  Changed "Icon Mode" to "Waypoint Display Mode" in the
         edit/create waypoint dialog box.

         Changed the column title "Icon Dspl" to "Wpt Displ Mode" on
         the waypoint list.

         Added depth and altitude to .csv file i/o.  Units are meters.
         
         Added altitude to .wpt, and .plt file i/o.  Units are feet.

         Sending to Street Atlas when .sa8 was selected was not
         reliable.  It now works.

======================================================================
September 20, 2000
A.00.20  Support for Ozi waypoint files version 1.1 added.  Support for
         version 1.0 dropped.  The basic difference is the symbol set
         is now set in what was Reserved 3.  If G7ToWin is used to
         read a Ozi .wpt 1.0 file then the symbol set is assumed to 
         be Garmin.  If this isn't correct, change 'Reserved 2' to
         garmin16, garmin, lei15 or lei28.  Other symbol sets are not
         supported.

======================================================================
September 20, 2000
A.00.19  Fugawi track files were exported incorrectly.  Every point
         was designated as a 'new' track.   Fugawi tracks were not
         read correctly, either.  Both errors were side effects of
         a structure change made over a year ago.

======================================================================
September 13, 2000
A.00.18  Added direct support for SA8 making the assumption that an
         SA8 file is 'close enough' to a SA7 file that using SA7 
         parameters 'works'.

======================================================================
September 13, 2000
A.00.17  A new configuration item "Convert Garmin Wpt Names" has been
         added to the File->configuration->General page.  If the box
         is checked then the following characters are allowed in 
         waypoint names as sent to Garmin GPS units (the quotes are
         not included).

         Waypoint names:"-ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
         Waypoint comments:"-ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 "

         If the box is NOT checked the following characters may be
         sent to the Garmin GPS unit:

         Waypoint names:"-ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 +_"
         Waypoint comments:"-ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 +_;?:/.,()'\"&#!*"

         Many of the older Garmin units "GPS45, 38, etc" are still in
         use and cannot accept spaces, + or _ in waypoint names.  If
         a waypoint name containing one of those characters is sent to
         the GPS the message "Invalid Wpt" results and the waypoint is
         ignored.  Checking the box will cause illegal characters to
         be converted to a '-'.

======================================================================
September 10, 2000
A.00.16  A missing ';' caused the icon conversion code to always be
         skipped.  Fixed.

======================================================================
September 7, 2000
A.00.15  The monitor code, enabled when 'Monitor' is checked on the
         File->Configuration->General page, will make substitutions
         in icon symbol values as read from g7towin .txt files.  These
         conversions are required to convert old 12XL symbol
         substitution values to the current ones.  This conversion
         allows the monitoring database to hold normalized icon symbol
         values.
         
         If the 'Monitor' check box is cleared then this conversion
         does not take place.  The 'Monitor' box should be
         cleared for virtually all users.

         If Monitor mode is set then .txt files contain the array
         used to convert 12 series icon values to Garmin values and
         the reverse.  This is a comment line and is used for
         informational purposes only.

======================================================================
September 4, 2000
A.00.14  Unlucky 13 strikes again :-).  I posted the debug version as
         A.00.13.  It's crippled, don't use it.
======================================================================
September 4, 2000
A.00.13  Comments in Garmin waypoint records could cause a program crash
         if the comment resembled a creation date but wasn't
         formatted properly as a creation date.

======================================================================
September 1, 2000
A.00.12  An error on a line in a .mlp file would cause the program to
         abort reading the file.  The program now skips continues with
         the next line on an error.

======================================================================
August 23, 2000
A.00.11  Fixed a minor bug in the saving of .mlp files.  If new items
         were added and 'File Save' was immediately pressed then the
         all items added since the last "OK" or color change were
         not updated and therefore not saved.

======================================================================
August 17, 2000
A.00.10  Changed 'Like Distance' calculation.  The icon and icon color
         are always used.  Use of the icon display type can be turned
         off with a check box on the Monitor Parmeter dialog.

         A check box to enable/disable edit of the 12 series icon
         translations was added.  If checked then the user can modify
         the number of the Garmin Symbol code to be used for each 12
         series icon.

======================================================================
August 16, 2000
A.00.09  Updated help file.  Removed an unneeded space character " "
         from the column names line in .mlp files.

======================================================================
August 15, 2000
A.00.08  Changed the Monitor Parameters page to also allow GPS12 icons
         translation pairs to be edited.

======================================================================
August 15, 2000
A.00.07  Fixed a typo.  The File->Configuration->General tab had it's
         name changed to '7'.

======================================================================
August 14, 2000
A.00.06  Added altitude to IGC B records.  In reading IGC files the
         Pressure altitude is given priority, i.e. if both GNSS and
         Pressure altitude is in the record the pressure altitude is
         used.

======================================================================
August 11, 2000
A.00.05  Added read of IGC track files.  Cleaned up a round off error
         in lat/long of the IGC track output routines.

======================================================================
August 10, 2000
A.00.04  The Beta designation will no longer be used.  It was 
         confusing to many users. 

         Changes/Additions:

         The File->Configuration->General page has two additions, a
         checkbox named Lookup and a button named Data which appears
         when the Lookup box is checked.  These additions apply to
         changes made for data collection.  Normal use is to leave
         the Lookup box unchecked.

         Saving a .www file will now save a .txt file in addition to
         the .www and .ttt files.


         The .www and .ttt file formats have changed.

         .www and .ttt files can now be read by reading the .www file.

======================================================================
August 4, 2000
A.00.03
Beta 34: Fixed 2 SA icon errors

======================================================================
June 21, 2000
A.00.03
Beta 33: Changed the placement of the HFDTE record in an .igc file.

======================================================================
June 20, 2000
A.00.03
Beta 32: Corrected an icon color problem in the 12CX code.

======================================================================
June 14, 2000
A.00.03
Beta 31: Corrected a bug in reading/writing track points to .CSV files.
         Changed the 'Name' column to contain the track name for eMap
         style tracks.  The name is made up of three parts separated
         by a pipe '|' character.  The three subfields of the name
         are:  name, color, display on map (1=yes)

======================================================================
A.00.03
Beta 30: IGC file naming bug fixed.

======================================================================
A.00.03
Beta 29: The track list now identifies the subtrack number.  The number
         follows the "*" in the track list window.

         Changed how the program sends subtracks to Lowrance/Eagle (LEI)
         units.

         The connected GPS must first be ID'd before sending plot trails
         to LEI units can be completed.

         There are three ways to send subtracks to plot trails on LEI
         units, the main Menu GPS Upload menu, the main menu Track
         Upload menu and by selecting subtracks in a Track List
         window and right clicking.  They are described below.

           Main Menu:

            GPS->Upload to GPS->First subtrack to Plot Trail n

               where n is 1 through the number of plot trails supported
               by the ID'd LEI unit.

               This will take the first subtrack from the loaded track
               log and send it to the GPS placing it into the plot trail
               you specify, 1-n.

            Tracks->Upload Tracks to GPS

               This will send the first 'n' subtracks to the GPS where
               'n' is the Minimum of the number of subtracks available
               in the loaded track log and the number of plot trails
               supported by the ID'd LEI unit.

               The first subtrack will go to plot trail 1, the second to
               plot trail 2, and so on until 'n' subtracks have been
               sent to the LEI unit.

           Track List right click

               If a single subtrack is selected in the Track List window
               a right click will bring up a menu containing:

                     Send Selected Tracks To GPS

               If this is selected then a 2nd submenu pops up asking
               which the user to specify the destination plot trail on
               the GPS.

               If more than 1 subtrack is selected, selecting

                     Send Selected Tracks To GPS

               will not pop up a submenu.  The program will attempt to
               send the first subtrack selected to the first plot trail
               on the GPS.  The second subtrack selected will be sent to
               plot trail 2 and so on until 'n' subtracks have been
               sent.  The Minimum described above under

                      Tracks->Upload Tracks to GPS

               applies.

======================================================================
A.00.03
Beta 28: Added Garmin command to turn power off.  This is not supported
         by all Garmin units and may cause problems if your unit doesn't
         support the command.  Use at your own risk.

======================================================================
A.00.03
Beta 27: Changed the way routes are read in.  Previous version would
         overwrite a route if a new route was read which had the same
         route number.  The program will now append the route waypoints
         read to the route being read.  This is in preparation for
         reading W+ comma separated files.

         A new configuration item has been added to the General tab.
         The separator for displayed distances, altitudes, and depths
         can be set to a comma or a period.  This selection can also be
         made in the waypoint list view window by right clicking and
         selecting distance units.  This does not have an effect on
         output files.  The separator on output files is still the
         period:'.'.

         Altitude and depth were not being saved to .txt files unless
         the waypoint had been read from a GPS.  Fixed.

======================================================================
A.00.03
Beta 26: Fixed an error in uploading tracks to Garmin units which used
         G3+ style track records.  The uploaded tracks were not
         displayed.

======================================================================
A.00.03
Beta 25: At the request of users a flag has been added to the general
         tab on the configuration page.  The new flag is "Send Aborts
         to Garmin Units?".  If checked then the program operates as
         before this change.  If the box is not checked then the
         Abort command sequence is never sent to Garmin units.

======================================================================
A.00.03
Beta 24: Sending waypoints to the GPS 55 AVD and GPS 89 was broken.
         This release attempts to fix that.

======================================================================
A.00.03
Beta 23: Reading waypoints from units which support record type D151
         would cause a program crash under Win98.  This was due to a
         typo in the code.

======================================================================
A.00.03
Beta 22: The correction for the Ozi .plt file header was not actually
         incorporated into Beta 21.  It is now.

======================================================================
A.00.03
Beta 21: The timestamp in the header of Ozi .plt files was not correct.
         It now correctly holds the GMT date/timestamp showing the time
         on the PC when the file was written.

         Fixed a memory leak which didn't cause problems under WinNT,
         but under Win98 it caused resources to be exhausted and the
         system to crash if G7ToWin was used to edit more than about
         20 waypoints without exiting.

======================================================================
A.00.03
Beta 20: Fixed a problem with G3Pilot waypoints which occured after
         editing the waypoint with G7ToWin.

======================================================================
A.00.03
Beta 19: Added HelpDir entry to the .ini file.  This entry points to
         the location where g7towin thinks g7towin.hlp and g7towin.cnt
         reside.

         Changed the way waypoint types D102 and D103 are sent to the
         GPS.  Minor error was corrected.

======================================================================
A.00.03
Beta 18: .clg files were not being closed properly when .trk files were
         also written.  Fixed.

======================================================================
A.00.03
Beta 17: .SA7 files were not being written.  Fixed.

======================================================================
A.00.03
Beta 16: Some outputs which required a 2 digit year had the value '100'
         instead of '00'.  Notably, the HFDTE field in the .igc file.
         Fixed.

======================================================================
A.00.03
Beta 15: Added navigate.exe tracks to the available outputs.  If 
         navigate.exe routes (.clg files) are saved and the program
         currently has tracks loaded then tracks will be saved as
         *.trk where * gets its name from the saved .clg file.

         NOTE:  This track file format is NOT compatible with Fugawi
                .trk files, the normal use for the .trk suffix.

======================================================================
A.00.03
Beta 14: If the configuration was set to 'Ignore' duplicate waypoints
         then reading routes could trigger the problem addressed in
         Beta 12.   Beta 12 had fixes for the 'Replace' duplicates
         option selection.  I believe the 'Ignore' option will now
         work when a route has duplicate waypoints.

======================================================================
A.00.03
Beta 13: Internal changes.  Not released.

======================================================================
A.00.03
Beta 12: Routes which had any waypoint used more than once were not
         handled properly.  Several things could happen including one of
         the duplicate entries simply disappearing.  I believe this is
         fixed, but further testing may reveal that it is not :-)

======================================================================
A.00.03
Beta 11: RE: WWW output files:

         Changed the output of the 'Abundance' column to be 1 if
         Abundance is missing or not used.  The value 1 will be useful
         more often than the -9999 value.

======================================================================
A.00.03
Beta 10: RE: WWW output files:

         Changed the output of the 'Abundance' column to be -9999 if
         Abundance is missing.

======================================================================
A.00.03
Beta 09: RE: WWW output files:
         
         Changed the output of the three columns added in Beta 08 to
         have values other than <blank> for missing items.  For the
         numerical column a missing number is represented by -9999.
         For alphabetical columns a missing value is represented by
         MISSING.

         Waypoint Name     Column1   Column2   Column3

         A1234X             A         1234      X
         12AA1X             MISSING   12        AA1X
         ABC3YQ             ABC       3         YQ
         A12345             A         12345     MISSING
         NONUMB             NONUMB    -9999     MISSING

======================================================================
A.00.03
Beta 08: Version 1 files do not support altitudes and depths.  Removed
         those from Version 1 file output.

         Version 1 files do not support c5 and c6 continuation records.
         Removed them from Version 1 file output.

         Added 3 columns to the .www waypoint file.  These three 
         columns are user selectable and the user can change their names.

         When .www is the selected output, a dialog box will pop up
         allowing each of the three columns to be checked to be output
         and the edit boxes allow the names of the columns to be
         changed.

         The three columns of data come from the waypoint name.  All
         characters of the waypoint name up to but excluding the first
         numereical character (0-9) go into column 1.  The number is
         decoded and goes into column 2.  Any trailing characters go
         into column 3.  Here are a few examples:


         Waypoint Name     Column1   Column2   Column3

         A1234X             A         1234      X
         12AA1X            <blank>    12        AA1X
         ABC3YQ             ABC       3         YQ
         A12345             A         12345     <blank>

         The status of the checkbox and the contents of the edit
         boxes are saved in the configuration file whenever the
         configuration file is written.

======================================================================
A.00.03
Beta 07: Internal changes.  Icon display mode could have new bugs
         introduced.

         eMap and eTrex units will not be sent a waypoint comment
         even though the D108 record allows comments.

======================================================================
A.00.03
Beta 06: Fixed a bug which caused edited waypoints to be sent to the
         eSeries GPS incorrectly.  Waypoints loaded but never edited
         were sent correctly.

======================================================================
A.00.03
Beta 05: Removed ':' from header line in .ttt files.

         Added a dropdown listbox which allows the user to select a
         'real' color to use in place of 'Default Color' for those
         units which send/receive a value called 'Default Color' in
         the Garmin interface specification.  If Default Color is
         chosen in the box then no changes are made to the color.

======================================================================
A.00.03
Beta 04: Changed several aspects of Timo files.  If curious about the
         new format save a .www file and look at the output.

======================================================================
A.00.03
Beta 03: Changed column headers for track distances as follows:

         DP = distance from the previous point to this point.
         DS = distance from the start of this segment to this point.
         DT = distance from the start of this track to this point.

         Forest and Fitness icons were reversed in GPS III class
         units.  Fixed.

======================================================================
A.00.03
Beta 02: Added distances to track list view window.
         The columns are DLP, DSS, and DTS followed by the distance
         units where: 

         DLP = distance from the previous point to this point.
         DSS = distance from the start of this segment to this point.
         DTS = distance from the start of this track to this point.

======================================================================
A.00.03
Beta 01: Added ability to read .www waypoint files.

======================================================================
A.00.02  30 Beta's is enough.  Releasing this as A.00.02

         Fixed errors with Proximity waypoints.  Proximity waypoints
         cannot be edited or displayed with g7towin, but they can be
         read and saved to a .txt file.

======================================================================
A.00.02
Beta 30: Added three columns to .www output file.  They are: Colour,
         Abundance, and Separation distance. 

         Output to a .www file first sorts the waypoints by time.  It
         then checks to see if the waypoint name is Axxxxx where 
         xxxxx is a number or a number(s) followed by characters.  If
         it is, then the number becomes the entry in the Abundance
         column.  If the first letter is not 'A' or the 2nd character
         is not a number then Abundance is set to zero.

         The color is one of 17 colors as defined in the Garmin 
         Interface Specification for the eMap series units.  It consists
         of 16 distinct color values, 0-15 and 255 for 'Default Color'.

         The Separation distance is the distance from the current 
         waypoint to the previous (in time) waypoint.  Since the list
         is sorted, it is also the previous waypoint in the list.

         The color values are as follows:

             Black----------  0
             Dark Red-------  1
             Dark Green-----  2
             Dark Yellow----  3
             Dark Blue------  4
             Dark Magenta---  5
             Dark Cyan------  6
             Light Gray-----  7
             Dark Gray------  8
             Red------------  9
             Green---------- 10
             Yellow--------- 11
             Blue----------- 12
             Magenta-------- 13
             Cyan----------- 14
             White---------- 15
             Default Color-- 16

         NOTE: The 'Default Color', 16, will be sent to the GPS as
               the color 255.

======================================================================
A.00.02
Beta 29: Added 'CRTD HH:MM DD-MMM-YY' to the 'check for time in
         comment field' code.

======================================================================
A.00.02
Beta 28: Modern Garmin units do not attach a valid time to the waypoint.
         For these waypoints the comment field (if the unit has a
         comment field) can be set to MM-DD-YY HH:MM:SS and this time
         will be used as the time of the waypoint.  If the comment field
         is not set and the unit does not send the time as part of the
         record then the time the record was downloaded to the PC will
         be used.

         Minor change to Timo type .www file output.

======================================================================
A.00.02 
Beta 27: Receiving a serial port error during display download could
         cause the program to crash.  Fixed.

         The middle two shades of grey were reversed in the eMap display
         bitmap.  Fixed.

======================================================================
A.00.02
Beta 26: Minor change to Timo type files.

======================================================================
A.00.02
Beta 25: Fixed a bitmap display download problem with the eMap.  The
         bottom 8 lines were caused by an indexing problem.

======================================================================
A.00.02
Beta 24: Waypoint symbol display properties were not displayed correctly
         at times. Fixed.

         Values used by the Reference record in waypoint list are now
         saved to the .ini file and re-read on startup.

======================================================================
A.00.02
Beta 23: Waypoint symbol display properties were not read correctly
         from Version 2 files.  Fixed.

======================================================================
A.00.02
Beta 22: For a third party:
         
         Added a new output format.  If the file to be saved is chosen
         with a suffix of .www then two files are saved.  fname.www and
         fname.ttt.  fname.www is a text file and contains comma
         delimited waypoints.  fname.ttt contains track records with
         comma delimited entries.  The formats are:

         Track files:

         Latitude:,Longitude:,Day:,Month:,Year:,Time:,Hour:,Minute:,Second:
         44.593990,-123.251980,9,6,1998,06:45:30,6,45,30
         44.593960,-123.257197,9,6,1998,06:45:30,6,45,30
         44.593690,-123.258980,9,6,1998,06:45:30,6,45,30
         ...
         ...
         ...
         44.593470,-123.260392,9,6,1998,06:45:30,6,45,30


         Waypoint files:

         Wpt name:,Latitude:,Longitude:,Date:,Day:,Month:,Year:,Time:,Hour:,Minute:,GS code:,GD code:
         126TRN,44.421303,-122.001853,16-Aug-98,16,8,1998,21:16,21,16,18,S+C
         1ST-B,44.566282,-123.267428,16-Aug-98,16,8,1998,21:16,21,16,10,S+C
         1STBCP,44.469582,-122.647123,16-Aug-98,16,8,1998,21:16,21,16,151,S+C
         245CHK,48.650352,-122.490912,16-Aug-98,16,8,1998,21:16,21,16,18,S+C
         ...
         ...
         ...
         2BUTES,44.191093,-121.914403,16-Aug-98,16,8,1998,21:16,21,16,18,S+C


======================================================================
A.00.02
Beta 21: Editing a waypoint should change it to a 'user' type of waypoint
         which supports altitude or depth.  Currently that is the D108
         waypoint type.  Therefore, if altitude or depth is involved
         in an edit the waypoint classification will be set to D108
         and continuation lines will be output to the text file.

         NOTE: in the .txt file depths and altitudes (part of the c5
               continuation record) are in meters.

======================================================================
A.00.02
Beta 20: Added edit of Waypoint Depth and Altitude.  The Altitude is
         the overriding value.  If the altitude is <1e10) then the
         depth value cannot exist.  To set a depth, first clear the
         altitude value and then enter your depth value.  Values
         greater than 1e10 are treated by the program as "doesn't
         exist".  Garmin uses a value of 1e24 to indicate the same
         state.

======================================================================
A.00.02
Beta 19: Added eMap route upload and route download.

         NOTE:  If a route that contains internal eMap waypoints (i.e.
                any waypoint that isn't a user created waypoint) is
                downloaded from the eMap, the route will be uploaded the
                using the same information.
                If, however, any waypoint in that route is edited in
                G7ToWin, then the specific internal waypoint information
                and route point link information will be lost and all
                waypoints will be transferred as user waypoints.  If the
                route is edited external to G7ToWin, i.e.  writing to a
                .txt file and editing the route, the specific
                waypoint/link information may be inaccurate.  Garmin
                doesn't say what the results of uploading bad link
                information may be.  User beware!

======================================================================
A.00.02
Beta 18: Fixed an icon upload problem with the eMap and StreetPilot

======================================================================
A.00.02
Beta 17: Fixed a fatal error which could happen when creating waypoints.

======================================================================
A.00.02
Beta 16: Changed some of the user interface and cleaned up a bit of old
         or unused code.  The Icon Family is now a dropdown list rather
         than a series of radio buttons.

         Added colors to the waypoint edit/create dialog box.  This
         means that older files will have to have their icon colors
         changed if the icon color was significant in that file.  The
         new colors reflect the Garmin colors now available in the
         waypoint data type used by the eMap.

         eMap waypoints and tracks are now supported.  The addition of
         the new waypoint features caused two new 'c' type records to be
         added to the .txt files, c5 and c6.

         The eMap display can now be downloaded.  To keep the code
         simple I do not modify the amount of data Garmin sends,
         therefore the bottom 8 lines of the bitmap will always be
         black.

         The new 'link' record type which is used to link two route
         waypoints will mean the addition of a third new 'c' type record
         in the .txt file, c7.  The code for this has not been written
         and routes are not fully supported yet.

         The *only* file type that will have the complete data will be
         the .txt files.  Storing data into any other type of file will
         necessarily strip some data, usually that found in a 'c' record
         in the .txt file or in the new Track line, 'N' which, for named
         tracks, contains the name, color and a flag to display or not
         display the track on the map.

         Symbol colors are now based upon the Garmin 16 color units.
         These 16 colors are converted to the destination colors in
         the following manner.

         If the destination does not have the color, but has a
         'default color' then the 'default color' value is sent.  If
         the destination does not have a 'default color' then the color
         black will be used.

         When Tracks that are named are sent to SA then the color of the
         first track segment will be the same color as the color
         specified in the named track.  This color is the one shown in a
         track list.  If the track is not named, then the color will be
         as specified in the configuration.  This color is only shown
         under File->Configuration->SA Circle Line Properties.  The
         succeeding track segments will use the configuration color.

         The name of a 'named track' is stored in .txt files, but not in
         any other type of file.  If a Named track is sent to SA and
         then saved by SA and the resulting .SA file is read back in by
         G7toWin the name, altitude, depth, color, and display
         information will be removed and the track will be the same as a
         pre-eMap track.

======================================================================
A.00.02
Beta 15: Cleaned up reading of LEI Icons (events) in version 1 files.

         More work on eMap, though eMap is NOT completed yet.  In fact
         it is still UNTESTED and in unlikely to work.

         This release is primarily to enable the program to read version
         1 DMM and UTM files properly.  Changes were made to g7to/g7tow
         which allowed version 1 files in DDD or DMS to be read if the
         'M' line was present.  G7ToWin could write version 1 DDD, DMM,
         UTM, and DMS files, including the 'M' line, but could not read
         version 1 DMS and UTM if the 'M' line was removed.  To maintain
         a semblance of compatibility with g7to/g7tow, G7ToWin can now
         read Version 1 DMM and UTM files w/o the 'M' line.  DMS and DDD
         files still require the 'M' line.

======================================================================
A.00.02
Beta 14: Added an option to *ignore* Z lines on input.  This will cause
         data which was stored in 'local' time to be read as if the
         'local' times were GMT.

         Updated help file to reflect some of the last few additions.

======================================================================
A.00.02
Beta 13: Added .csv files to local time support.  The line in the .csv
         file which give the offset is:

         ZoneOffset:,x.xxxxx

======================================================================
A.00.02
Beta 12: Added a checkbox to the general configuration screen named
         "Local Time".  If checked, then times output to .txt files for
         Waypoints and Tracks will be adjusted for the local time zone
         on the PC running the program and output after conversion to
         the local time zone.

         This adds a 'Z line' to the .txt file.  The format of the Z
         command is:

         Z  1.234
         
         a Z in the first column and a floating point
         number starting at character column 3.  This number is the
         number of hours that the local time is offset from GMT.  For
         instance, the Pacific Standard Time Zone is GMT-8 so the line
         is:

         Z  -8.0

         On reading, the time is converted back to GMT using the value
         in the Z line.  If there is no Z line then the times in the 
         text file are assumed to be in GMT.

         NOTE:  All times displayed by the program are still in GMT.

         This is useful if one wishes to look at specific local date and
         time for tracks or waypoints.  For example, set the "Local
         Time" checkbox.  Save the data to a .txt file.  Clear the data.
         Edit the file to remove the Z line (or simply comment it out
         with a "#" as the first character in the line).  Then load it
         back in.  You will have a data file loaded in Local time.  To
         convert it back to GMT one would have to save it again, Clear
         the data from the program and re-insert the 'Z' line and
         re-load the file.

======================================================================
A.00.02 
Beta 11: Some debug code was left in which caused a crash on
         file upload or download to the GPS.

======================================================================
A.00.02
Beta 10: Began adding eMap coverage.   The emap is NOT supported yet.

         Added a check box to the text output modifiers.  This check
         box is named:
         
         Log Display

         If this box is checked the program will output all data sent to
         the grey display on the main window to the file DisplayOutput.
         The file DisplayOutput is created in the current directory at
         the time the first display line is written.  Error checking is
         not performed.  This addition is primarily for debugging and
         the file will contain *lots* of information.

         Fixed icon problem with GPS II+ version 3.03.

======================================================================
A.00.02
Beta 09: Secondary datums (from g7windatums.txt file) were not being
         incorporated correctly.  Fixed.

======================================================================
A.00.02
Beta 08: Added SA7 file type.  It appears that SA6 and SA7 share the
         same file format.  This release is based upon that premis. If
         it turns out that SA7 has added features they will be added
         in a later release.

======================================================================
A.00.02
Beta 07: Waypoint upload to a 12CX was still broken.  Fixed (I think :-).
         I do not have a 12CX, so this debugging is being done on a
         long distance basis.

======================================================================
A.00.02
Beta 06: Waypoint upload to a 12CX was broken.  Fixed (I think :-).

======================================================================
A.00.02
Beta 05: Added the ability to map the 16 symbols from the Garmin GPS
         12, 12XL, and GPSII+ to any of the internal Garmin symbols.
         The .ini file, g7towin.ini, contains a line defining the
         mapping (or at least it will as soon as you save the .ini
         file using Beta 05 or above).  The line has the following
         format:

         G12XL/II+_Symbol_Mapping=

         Following the '=' is 16 decimal numbers separated by commas.
         The numbers represent the internal symbol the 'Xth' symbol
         in the 12XL is mapped to.  For instance, if the first number
         is 18, then the first 12XL symbol will be mapped to the
         Garmin symbol 18 which is a waypoint dot.  The line must
         not contain spaces anywhere in the line.

         To restore the defaults, simply delete the line from the
         .ini file and execute G7ToWin and save the configuration.
         The original values will be restored in the .ini file.

         This feature was added at the request of a research team that
         uses 12XL's to collect data wherein different data is
         represented by different symbols.

======================================================================
A.00.02
Beta 04: Remove Exact Wpt Dupes in File->Configuration worked only on
         file input.  It has been extended to work for all input.

         Added a Waypoint List view menu item to set the icon color of
         all selected waypoints to the reference icon color.

======================================================================
A.00.02
Beta 03: Due to a typo, uploading almanacs to Garmin units was always
         disabled.  Fixed.  Almanacs can now be uploaded to Garmin
         units.

======================================================================
A.00.02
Beta 02: If a text file was read in and then immediately written out to
         an SA6 file it was possible for the center of map calculation
         to be skipped.  The default was taken and the default had a
         typo in it.  The center of the map ended up at N40 E100 rather
         than N40 W100.

======================================================================
A.00.02
Beta 01: Changed the waypoint edit Comment box so that it scrolls.  The
         width was not wide enough for some 20 character combinations.
         As the box accepts up to 40 characters, the best solution was
         to make it scrollable.

======================================================================

A.00.01  Download of all tracks from a LEI unit did not work from the
         main Track menu.  Fixed.

======================================================================
A.00.01
Beta 01: Added an option to allow all times output to .txt files to be
         Garmin 'zero' time:  Sun Dec 31 00:00:00 1989.  This applies to
         waypoint and track entries only.  This will remove the time
         area as being different and facilitate finding differences
         between files.  The default is off.  The option is ZeroTime and
         is found in File->Configuration->General

         Added 3 new GPS III+ icons:  Fitness Center, Live Theater, and
         Movie Theater.  This will require the user to redefine the
         default GIII/GIII+ icon in the configuration.  The default icon
         is an index into the array of icons and the array has changed.

======================================================================

Official release of G7ToWin version A.00.00

All *known* bugs are fixed.  I'm sure there are a lot more, but I have
not received an error report for 2 weeks so here goes....

======================================================================

RC 70:    A race condition in the menuing could cause the File-Save As
          entry to be disabled incorrectly when the platform is Win98
          or Win95.  Fixed.

======================================================================

RC 69:    Blank lines in an Ozi plot file would cause the program to
          crash.  These lines are illegal, but Ozi ignores them, so I
          will, too.

          Ozi route files weren't being closed until the program exited.
          The file is now closed when the file write has completed.

======================================================================

RC 68:    If sorting after read was turned on and a file that contained
          zero waypoints was read the program would crash.  Fixed.

======================================================================

RC 67:    If a .CSV record did not contain the time the program did not
          substitute the timestamp of the file.  This left waypoints
          with bad times.  If any element of the time is not defined
          then the time of the record is set to the datestamp on the
          file.

======================================================================

RC 66:    Reading a version 1 CSV file after reading a version 2 CSV
          file caused the program to fail.  Fixed.

======================================================================

RC 65:    Tracks->Upload Tracks to GPS was always enabled.  Now it's
          only enabled when tracks have been loaded.

          Loaded almanac did not enable File->Save As.  Fixed

======================================================================

RC 64:    Send to SA->All sometimes failed to send waypoints.  Fixed.

======================================================================

RC 63:    Corrected a problem uploading selected waypoints to LEI units.

          Waypoint upload to LEI units was not turning off the serial
          port when the upload(s) completed.  Fixed

======================================================================

RC 62:    Corrected a problem reading waypoint symbols, display colors
          and display modes in .csv files.

======================================================================

RC 61:    Found a typo in the download of 12CX waypoints.  I think it's
          fixed, but I can't test it--I don't have acces to a 12CX.

======================================================================

RC 60:    I now have access to a Street Pilot ColorMap.  Street Pilot
          Symbols now use the Street Pilot ColorMap Symbols, including
          color.

          Modified the pallet slightly so the colors on downloaded
          display bitmaps match to *my* two display CRT's.  YMMV.

          Re-arranged some of the entries in the General configuration
          tab.

======================================================================

RC 59:    Fixed a debug file naming problem.

======================================================================

RC 58:    Waypoint List Right Click changes:

            Re-arranged the right click menu for waypoints.

            Added a couple of selection features to the wpt rt click.

            Cleaned up keyboard a bit.  This is a crude keyboard handler
            intended only to select waypoints.

======================================================================

RC 57:    Added a third option to the search.  The 'Record' search
          matches if the typed substring exists in either the waypoint
          name or the waypoint comment.  The searches are not case
          sensitive.

======================================================================

RC 56:    Turned on a trivial waypoint name or comment search.
          
          Typing on the keyboard when the waypoint list is displayed
          enters the typed key into a buffer and activates a search.

          Pressing ESC will clear the buffer allowing a new search.

          Pressing the Backapace key will remove the last character
          from the buffer.

          Pressing the TAB key will toggle the search between waypoint
          name and waypoint comment.  The search compares the first 'n'
          characters where 'n' is the length of the comparison buffer,
          therefore it is better to sort by waypoint names when
          searching names and waypoint comment when searching comments.

          The comparison buffer and search type is shown in the first
          status bar box.

          The search stops when the first match is found and the focus
          is set to the waypoint.  The waypoint is NOT selected.

======================================================================

RC 55:    Modified the Edit a Track dialog box so that the first element
          in the track list must be a new track element and the New
          track checkbox is grayed out.

======================================================================

RC 54:    Deleting the first element of the first track did not set the
          next track element as the first track element.  This caused
          several routines to fail, sometimes with a program crash.

======================================================================

RC 53:    Changed waypoint list right click sub-menu items:

          Delete waypoints used in route -> Select them
          Delete waypoints not used in route -> Select them

          Added a count of selected waypoints in the 3rd status bar
          area.

          Sorting a waypoint list now causes all items to be
          de-selected.

======================================================================

RC 52:    Added entry in Right Click sub-menu of Waypoint List to select
          all waypoints.

          Added an entry in the Right Click sub-menu which will select
          all waypoints with duplicate names.

======================================================================

RC 51:    Do do popular request (and because it was very easy to do :-)
          I changed the way routes are read.  Previous versions would
          overwrite a route in the route buffer if it had the same
          number as an existing route.  This affected all LEI units and
          all Garmin units which report a route number.

          G7ToWin now merges all read routes.  This means that if you
          read route information from a GPS twice, then all routes will
          be duplicated in G7ToWin's route buffer and the last ones read
          will have new route numbers.

          It is up to the user to make sure that all unwanted routes are
          deleted and routes numbered properly for those units which use
          route numbers.

======================================================================

RC 50:    Changed some menu labels for clarity.

          Must select only ONE waypoints when setting REFERENCE waypoint
          else the menu item is greyed out.

          Added menu item in waypoint list right click menu which
          removes only waypoints that are in a route.  This also removes
          them from the route.

          Added an item to the dialog box which pops up if
          'File->Configuration->General->Select Items for Saving to Text
          Files' is checked.  This item, Waypoints Not Used in Routes,
          is mutually exclusive with Save Waypoints.

======================================================================

RC 49:    When changing from Garmin to LEI after a communication with
          the Garmin unit the program did not request an ID from the
          LEI before starting.  This lead to various failures.  Fixed.

          Changed slightly the way tracks are sent to SA.

          Cosmetic change to waypoint list when UTM is displayed.

          Distance calculations printed to text file were incorrect.

======================================================================

RC 48:    Distances less than .1 nautical mile were being shown as 0.000
          in the waypoint list.  Fixed.

          .txt output file type can be set to 1 or 2.  Set it to 1 to be
          compatible with g7to and g7tow.  If data exchange with neither
          of the command line programs is contemplated, leave it at 2.
          This value is set in the General configuration tab.

======================================================================

RC 47:    Added a 'Ref Dist' column to the waypoint list.  This shows
          the distance in miles from the reference waypoint to the
          waypoint in miles.  The distance is calculated using Sinnot's
          formula.

          If the Reference Waypoint is not set, it is automatically set
          to the first waypoint read from any input.

          Once the Reference waypoint is set, only the user can change
          it through the waypoint list right click menu.

          The user can choose to have Statute miles, Nautical miles or
          Kilometers displayed.  The choice is made in the General tab
          of the Configuration.

          NOTE:  The reference waypoint is a separate waypoint, even if
                 the waypoint used to set the reference waypoint is
                 change/deleted, etc.  The value of the reference
                 waypoint does NOT change.


          It is now possible to chose how the program handles duplicate
          waypoints when they are read into the program.  A name search
          comparing the pending waypoint to the waypoints already read
          into the program is made.  If a match is found then one of
          three actions is taken depending upon the state of the 'Read
          Duplicate Waypoint' parameter which is set in the General
          Configuration tab.

          If the parameter is:
          
            Ignore:  The pending waypoint is discarded.
            Replace: The waypoint currently in the program is replaced
                     with the pending waypoint.
            Merge:   The pending waypoint is merged into the program.

          NOTE:  These actions take place before any other actions.  If
                 the parameter is set to Merge and the 'Remove Exact Wpt
                 Dupes' box is checked it is possible the 'Merged'
                 waypoint will remain and the 'original' waypoint will
                 be removed.  It is usually better to leave the 'Remove
                 Exact Wpt Dupes' box unchecked and remove exact dups
                 manually.

======================================================================

RC 46:    By popular request a method to set waypoint icons and waypoint
          icon display mode to the same value has been added.
          
          The method is accesed out of the waypoint list.  First, select
          one of the waypoints you wish to change and set it's icon
          and/or icon display mode.  Right click on the waypoint to both
          select it and bring up the popup menu.  One of the new menu
          entries is 'Set Reference Waypoint'.  When you select this
          menu item, a copy of the first selected waypoint is made.  Now
          select all of the waypoints that you wish to have the same
          icon or same icon display mode.  Right click on the selection
          and chose to set either icons or icon display mode to the
          reference icon.

          The Icon Property page in the configuration was not filling
          the default icon drop down list correctly.  Fixed.

======================================================================

RC 45:    Added a dialog box which give the user a chance to change
          LEI waypoint upload and download start information when
          uploading or downloading waypoints/routes to a LEI GPS.

======================================================================

RC 44:    Changed "OK" to "Save WPT" in create waypoint dialog.
          Changed "Done" to "Save WPT & Exit" in dialog.

          Changed "OK" to "Save Event" in create Event dialog.
          changed "Done" to "Save Event & Exit" in dialog.

          Added route waypoint upload start point to General Config
          Tab.

          Changed the way route waypoints are uploaded to LEI units.
          All waypoints are first uploaded starting at the waypoint
          start point as specified in the General tab.  After this a
          check is made to see if the waypoint upload start and route
          waypoint upload start are in the same place.  If so, routes
          are uploaded as before.  If they are not the same, then
          waypoints are again uploaded starting at the route waypoint
          upload start position.  It is recommended that 'waypoints' and
          'routes' be stored in different source files.

          Added a 'Delete All Selected Waypoints not in a Route' menu
          item to the Waypoint list right click menu.

          Minor cleanup in event handling.


======================================================================

RC 43:    Added a column name line to .csv output.  This line is for
          waypoints.

          Events didn't always download to the PC properly.  Fixed.

          Removed GPS->Commands->GetID as this command was the same
          as GPS->Initialize GPS.  The command GPS->Initialize GPS
          has been renamed to Get GPS ID.

          The zone letter is required to be input into the Latitude
          field when the mode is UTM.  The program now requires it.

======================================================================

RC 42:    Fixed a problem reading Ozi route files.  Fixed a problem
          reading Fugawi waypoint files.  Both problems involved
          incorrect date conversions.

======================================================================

RC 41:    Added icon color and icon display type to the waypoint list.
          This will allow the list to be sorted by these items.

          Changed output format of waypoints in .txt files.  The symbol
          display type is now an alpha-numeric.  The symbol color is
          output etween the symbol and symbol display type.  The
          separator character between the waypoint comment and the
          waypoint symbol and the waypoint color and the waypoint symbol
          display style has been changed from a semicolon to a caret
          '^'.  This change was made because the GIII+ supports a ';' in
          the waypoint comment.

          The file version of the .txt and .csv files is now output on
          the first line.

          The same changes were made to .csv files.

          Routes are now output to .csv files.

          When editing a route waypoint the waypoint name can be
          changed.  This change will affect all waypoints in all routes
          that have the same waypoint Id.

          Added a short description of the waypoint .txt files to the
          help file.

          Fixed a bug in uploading routes to LEI units.  Waypoints were
          not being sent before the routes when the upload was called
          from the route list or the main route menu.

======================================================================

RC 40:    Did a bit of cleanup on the transfer of icons to Ozi .wpt and
          .evt files.  The icons are correct for the Garmin GPS III+ if
          the GPS is GARMIN and the GIII/GIII+ box is checked in the 
          configuration.

          Other Garmin units will be less correct.  No attempt has been
          made to make the icons correct for units other than the
          GPSIII+.

======================================================================

RC 39:    Events wouldn't upload to a LEI unit from the Event menu.
          Fixed.

          The Get GPS ID function did not hold onto the window so if
          a list (waypoint, event, track, route) was displayed the
          result of the GetID funciton would be covered.  Fixed.

          Fixed a problem with reading Ozi .rte files.

======================================================================

RC 38:    More work on track list.  Track elements can be created and
          inserted.

          Updated help file.

======================================================================

RC 37:    LEI Unit trail upload from the trail list window now works.

          Debugging begins.  When a few days go by with no new bugs
          reported I will release the first version.

======================================================================

RC 36:    More display cleanup.

          Added Event List function.  This uses a list window to display
          Events.  Events are LEI Icons.  Events can be edited, created
          or deleted in a manner similar to waypoints.

          Added Track List function.  This has NOT been debugged at all
          for the Lowrance units and I guarantee some things, such as
          Send Selected Tracks to GPS will NOT work with the LEI units.

          Debugging has been started on it's use with Garmin units.  When
          it's finished the LEI units will be debugged.

          In the list view window for tracks each track element that is
          the first one in a segment is marked with a '*'.  All elements
          up to but not including the next starred element make up a track
          segment.

          Adding new elements is not supported.  Any element can be changed
          to/from a 'first element'.  Tracks can be split in this manner and
          adjacent track segments can be combined by removing the 'first
          element' marker in the edit window.

          For sending tracks to a file, GPS or SA the entire track segment
          which contains any selected element will be sent.

          When Deleting, either the element or the track segment can be
          deleted.

          The help file is NOT up to date.

          Added the Garmin icon symbol number to the waypoint list.
          This allows a sort on the icon number.  The Garmin icon symbol
          numbers can be found in the Garmin interface document which is
          on the Garmin web site.

======================================================================

RC 35:    More display cleanup.

          Changed sort on date/time column in waypoint list to sort
          by actual time rather than alphabetically on the date time
          string.

======================================================================

RC 34:    Bitmap display fixed.  This was broken in RC32.

======================================================================

RC 33:    Further cleanup in the display routines.

          If a route download was interrupted by pressing ESC the
          download wasn't properly terminated and future waypoints
          downloaded would go into the route being read at the time
          ESC was pressed.  Pressing ESC now properly terminates the
          route download.

          Added 'remove' items from waypoint list right click to the
          main waypoint menu.

          Removed the unnecessary 'Cancel' item from right click of
          waypoints and routes.

          Removed the 'Configure' item from right click on waypoints
          and routes.  The 'File->Configure' item is accessable w/o
          clearing the current display.

======================================================================

RC 32:    Changed the program so that clicking on the menu bar does not
          clear the client window.  Most items displayed will remain 
          displayed until a menu item is chosen which causes the 
          display to change.  This change was made because several
          users thought it would be a good idea.

======================================================================

RC 31:    Waypoints from the Garmin 12CX were not being downloaded

======================================================================

RC 30:    Waypoints from the Garmin 12CX were not being downloaded
          correctly.  This release is the first attempt at correcting
          that.  I probably won't hear back as to the suitability of
          the new code until after July 9, 1999

======================================================================

RC 29:    Changed the format for Street Pilot waypoints in a .txt file.
          The waypoint name in the 'W' line will be 'spw' as before and
          the actual waypoint name will be in continuation record 'c1'
          as before.  The first 20 characters of the waypoint name will
          also be in the waypoint comment field.

          In a waypoint list window the Street Pilot waypoints will
          appear as normal waypoints with one exception, the comment
          field will say 'SP WAYPOINT'.  
          
          In creating or editing a waypoint, if the comment field is
          exactly SP WAYPOINT then that waypoint will be created as a
          Street Pilot waypoint.

======================================================================

RC 28:    Inadvertently removed the lines which displayed the bitmap.
          Lines restored.

======================================================================

RC 27:    By popular request...the last file name and extension used in
          file read and write is saved in the .ini file.  If the
          configuration is saved then the program will look for the last
          read/saved file.ext when the next read/save is executed.  This
          does not apply to .igc files because they cannot be read by
          the program and can only be written with the .igc suffix.

======================================================================

RC 26:    Changed the way the program handles waypoint names and
          comments.  They are converted to uppercase on output to
          the GPS, not at other times.  Previous versions converted
          to upper case automatically.

          Added the display of the point number for a waypoint in a
          route list window.

          Added 'Send Waypoint to SA' item in the Route List
          right click menu.

======================================================================

RC 25:    DeLorme often places a bar '|' in text data.  Garmin units do
          not like to see the bar and code is added to replace the bar
          with a dash '-'.

          Removed the (loaded: nnn) in the middle status bar.  This
          displayed the number of datums loaded into the program.

          Reading a file that did not contain waypoints would cause
          the program to abort if the 'remove exact duplicates' flag
          was set.  Fixed.

======================================================================

RC 24:    Changed the Force dupe removal box in File->Configuration->
          General to apply on waypoint input/creation and to apply only
          to Exact Dupes where Exact Dupes are those with the Name, Lat
          and Long values identical.  If this box is checked then all
          but one of the Exact Dupes are removed after each input file
          is read.

          The Waypoint List right click dupe removal still removes
          based upon waypoint name only.  It will not remove the name
          only dupe if it is used in a route.

          Fixed the code which saved/read startup directories.  A
          blank line after the '=' in the .ini file would cause the
          program to abort.

======================================================================

RC 23:    Worked on SP routes.  User created routes can now be uploaded.

======================================================================

RC 22:    Turned on the waypoint ID numbering.  Each waypoint has an
          'Id number' assigned to it.  This allows differentiating 
          between waypoints with identical names but different values.
          It also allows tying route waypoints to specific waypoints.

          This Id is not editable by the user, but it is shown whenever
          a waypoint name is shown.  In the Waypoint List window it
          has it's own column and can be sorted on.  In the route
          list window each waypoint name consists of:

          name ; id#

          For the most part the user can ignore the Id number unless
          it is desired to edit a specific waypoint which has the same
          waypoint name as another waypoint.

          This program always removes exact waypoint duplicates on input
          and adjusts the Id accordingly.

          The removal of waypoints with just the name duplicated will
          not remove waypoints that are in routes.  This is the remove
          duplicates that can be forced to happen after a sort.  It is
          also called from a right click of a waypoint in the waypoint
          list window.

          Turning on this 'waypoint Id' is the first step to making 
          Street Pilot routes work correctly and is likely to uncover
          some bugs.

======================================================================

RC 21:    Enabled the 'Save Configuration at Exit' checkbox.  If this
          box (in File->Configuration->General) is checked the 
          configuration file will be written just before program exit.
          The default is off, i.e. don't automatically save config.

======================================================================

RC 20:    The first waypoint in any file that had a Datum line other
          than WGS-84 was converted incorrectly.  Fixed.

======================================================================

RC 19:    File read, File save and IGC save all have their own
          working directory.  The directory value for these three
          file operation dialog boxes are saved to g7towin.ini if
          the configuration is saved.

======================================================================

RC 18:    Fixed several errors in Reading/Writing of navigate.exe
          files (*.clg).

          Fixed crashed caused by attempting to get the GPS display 
          when no GPS was connedted to the serial port.

          Baud rate was missing from serial port setup.  This error
          was introduced in RC17.

          Modified the read routines to remove all but the first
          waypoint which have the exact same name, latitude and
          longitued.  
          
          The 'Remove Duplicate Waypoints' function, which has been
          available for some time, removes waypoints with duplicate
          names.  The lat/long values are not involved in this check for
          duplication.

======================================================================

RC 17:    I/O to edit box did not convert datums properly.

          Fixed a hardware handshaking problem that arose whenever
          RAS would take over and then release the serial port.

          Fixed a reading problem when reading navigate.clg route
          files.  I no longer use this file type and rely on users
          to let me know when it fails. 

======================================================================

RC 16:    UTM conversion wasn't initialized.  This error was introduced
          in RC 13.

          At times deleting all but one waypoint in a waypoint list
          window would cause the program to abort.

          Editing a route would cause the route to be 'half deleted'.
          This left the program in a dangerous state and an abort 
          usually happened if anything having to do with routes was
          attempted.  This error was introduced in RC 13.

======================================================================

RC 15:    Added RightClick menu to the Route List.

======================================================================

RC 14:    Oops! Left code to upload to GPS turned off in RC13.

======================================================================

RC 13:    Re: RightClick in Waypoint list window
          
              Added send selected waypoints to GPS.
              Added send selected waypoints to a file. 

              This required re-writing some of the output routines and
              may have introduced new bugs.

          Removed a race condition from the code accomplishing the
          delete selected waypoints part of the waypoint list right
          click.

          Datum Conversion problems addressed:

            Not all items output to .txt and .csv files were
            converted to the output datum.  Fixed.

            The Waypoint List window and the Waypoint create/edit window
            converted the Lat/Long values to the output datum on
            display, but not on input.  Fixed.

            The Waypoint Create and Edit window data is assumed to be in
            the selected datum (shown in the middle part of status bar)
            and will be converted to WGS-84 for internal storage.

            This datum is separate from the datum used to read .txt and
            .csv files.  When reading .txt or .csv files the datum is
            set to WGS-84 at the time the file read is started.  To have
            Lat/Long information in other datums stored in .txt and .csv
            files the file must have a 'D' line which informs G7ToWin
            that the Lat/Long values in the file are in a datum other
            than WGS-84.

              These changes required a rewrite of the code which called
              the datum conversion routines and minor modifications to
              the datum conversion routines.  This may have introduced
              new bugs.

            Internal Lat/Long data, which is stored in WGS-84, will be
            converted to the selected output datum for output to .txt
            and .csv files and when output to a Waypoint List window or
            a Create/Edit Waypoint dialog box.

======================================================================

RC 12:    Reading incomplete SA routes created a waypoint without
          Latitude, Longitude or Date information.  When written to
          a .csv or .txt file the resulting file would be incorrect
          and cause a program crash when read by G7ToWin.  It should
          be fixed.

======================================================================

RC 11:    Converting some Icons from internal format to Street Atlas
          format would fail on all internal icons >256.  Fixed.

======================================================================

RC 10:    Reading .csv files would abort if time parameters were not
          included in waypoint and track records.  The program now
          substitutes the file time stamp when the time elements are not
          present in the file.

======================================================================

RC 09:    Sending waypoints to SA from a waypoint list would mark all
          tracks inactive and therefore tracks could no longer be sent
          to SA.  Fixed.

======================================================================

RC 08:    Waypoint list window would become sorted on sending waypoints
          to SA via RightClick in the display window.  The display, 
          however, wouldn't reflect this.  Waypoints being sent to SA
          via RightClick from the waypoint list window will not be
          sorted.

          Fixed a problem which caused waypoints uploaded to the
          Street Pilot to be invalid.

          Cosmetic cleanup of waypoint list after using Right Click to
          delete selected waypoints.

======================================================================

RC 07:    Added 15 new Garmin GPSIII+ Icons introduced in GPSIII+
          version 2.02.

======================================================================

RC 06:    More tuning of Color Street Pilot colors in display download.

          Added a Force SA Line Properties check box to the SA
          Line/Circle Property tab.  If this box is checked the values
          (color, thickness, style) for track lines is taken from the
          configuration, not from the values within the track.  The
          values within the track are set at the time the track is read
          in and currently cannot be changed.

======================================================================

RC 05:    Fixed a conversion problem which occured when reading in
          certain files that were in degree decimal mode and G7ToWin
          had UTM set in the configuration file.  Those files should
          not have had the UTM conversion applied and now they don't.

          The only files which support UTM i/o are .txt and .csv.

======================================================================

RC 04:    More color swapping on the Color Street Pilot display
          download.

======================================================================

RC 03:    Fixed a file suffix error for saving files.

          Added display download for the Color Street Pilot.  The colors
          may not be exactly right.

======================================================================

RC 02:    Fixed a Garmin upload waypoint problem.  Most waypoint
          symbols were sent as the default icon.

======================================================================

RC 01:    Added upload/download to Waypoint and Route menu's

          Waypoints deleted with a right click from the waypoint list
          window were not being deleted from routes.  They now are.

======================================================================

RC 00:    Added default icons for the Street Pilot, GPSIII/+, GII+/12XL,
          Street Atlas, Lowrance 15 icon units and Lowrance 28 Icon
          units.  See the help file for a description of the function
          of the default icons.

          The default icons are set in the File->Configuration->Icon
          Properties tab.

======================================================================

Beta 82:  The Waypoint icon in the Street Pilot was inverted.  Fixed.
          Speeded up the redraw of an initialized Waypoint List.

          This is the last 'beta'.  The program is nearing release and
          'Release Candidate' versions will be used.  No new features
          will be added--bug fixes only.

======================================================================

Beta 81:  The 'zoo' (elephant) icon from the SP was not recognized.

          Can now access Configuration from right clicking on a
          waypoint list.

======================================================================

Beta 80:  Attempted to fix a crash that could occur when sorting
          the waypoint list by clicking on a column.  This crash did
          not occur in WinNT but did occur in Win95 and Win98.  I
          think it was a race condition which I've now removed. I
          *think* it's fixed.

          NOTE:  The Street Pilot code is not completed yet.

======================================================================

Beta 79:  Added 50 Street Pilot Icon symbols.

          Made waypoint edit an edit in place.  Previously the waypoint
          edit function could be used to create a new waypoint by
          changing the name which caused it to be moved to the
          end of the waypoint list.  A new waypoint cannot be made
          by editing a waypoint.

======================================================================

Beta 78:  Added sorting to the waypoint list.

          Added a check box to the General configuration Tab.  This
          check box, Force Wpt Dupe Removal, allows the user to have
          control over the removal of duplicate waypoints.  If this
          box is checked, each time the waypoint list is sorted
          (which is virtually everytime the number of waypoints changes)
          duplicate waypoints will be removed.

          Added 'Remove Duplicate Waypoints' to the menu popped up
          when the waypoint list is Right Clicked.

======================================================================

Beta 77:  Loading a waypoint file after deleting waypoints from the
          waypoint list would GPF.  Fixed.

======================================================================

Beta 76:  Added a checkbox to the General property page under File->
          Configuration.  If the box 'Select Items for Saving to Text
          Files' is checked and a .txt file is being saved then the
          program will prompt for which items to save.  If the box
          is not checked then all items are saved.

======================================================================

Beta 75:  Fixed a problem with LEI Icons.  All LEI icons were treated as
          if they were for a 15 icon machine.

======================================================================

Beta 74:  Added some right click items to the waypoint list window:

          Delete Selected Waypoints
          Send Selected to SA

======================================================================

Beta 73:  Fixed an Ozi icon error.  This fix is temporary and will
          be expanded upon if/when OziExplorer adds the 8 new icons
          available in the Garmin GPS III Plus.

          Changed the default Ozi icon to the waypoint symbol.

======================================================================

Beta 72:  Fixed a G3/G3+ icon error.  Medical Facility and Mine were
          reversed.

======================================================================

Beta 71:  Fixed a G3/G3+ icon error.  One was incorrect and 4 were
          rotated.

======================================================================

Beta 70:  Moved Copy display to bitmap menu item to GPS menu.

          Added A command to save the program configuration data from
          the File menu.  Typing Ctrl+F will also save the configuration
          file.

          Added the current main program window placement and size to
          the startup file.  Setting Save Startup Location in the
          File->Configuration General tab will enable this.

======================================================================

Beta 69:  G3 icons files were named incorrectly.  This caused the
          displayed Icon bitmaps to appear to be scrambled.  Fixed

======================================================================

Beta 68:  Added copy to clipboard for display bitmaps.  This copy is
          performed as a DIB copy.

          NOTE: I have had a report that Garmin III icons are not
                rendered correctly.  I cannot test this until Garmin
                returns my G3+.  I have no idea when that will be, but
                hope it will be before the middle of April.  Until that
                time I will not attempt to do more than very minor fixes
                in the Garmin area of the code.

======================================================================

Beta 67:  Fixed a problem reading SA files where the Icon symbol was
          reset to the default if the SA text was NAME;DESCRIPTION

======================================================================

Beta 66:  Additional help file modifications.

          Fixed a bug which caused the first waypoint in routes uploaded
          to the Lowrance units to be incorrect.

======================================================================

Beta 65:  Beginnings of help now available.  The files G7ToWin.hlp and
          G7ToWin.cnt should reside in the startup directory along with
          G7ToWin.exe.  The help file is an effort in progress.  Please
          report errors or difficulties with the help file.

          Fixed an error which would result in waypoints entered after a
          route upload being erronously added to the just loaded route.

          Added option to save the internal datum information to a
          file for user inspection.

======================================================================

Beta 64:  Minor route 0 upload to SA 6 problem introduced in B61 fixed.

======================================================================

Beta 63:  Swapped day and month in IGC track date record.

          Fixed a small bug in the open/save file dialog box.  This
          bug did not have an effect on the release code, only on
          debug code.

======================================================================

Beta 62:  Files sent to SA as sa3 were going as sa4.  Fixed.

          Sending tracks downloaded from LEI units to SA caused G7ToWin
          to crash.  Fixed.

          2 formatting errors in IGC output fixed.

          IGC track now output in selected output datum.  Using a
          'standard' file name now supported.

======================================================================

Beta 61:  Added ability to specify an intermediate waypoint to be a
          Via.  This only applies if the specified Send To SA file
          type is SA6.

          Added ability to specify the SA for Send To SA command.
          SA3, SA4, SA5 and SA6 format is supported.

          Added IGC file header dialog box to save of IGC track file.

======================================================================

Beta 60:  If the icon selected was Garmin GPS III or Garmin 12 then
          a double click on the waypoint list would immediately close
          the edit dialog box.  Fixed.

======================================================================

Beta 59:  Input files weren't always closed after reading the input.

          WinNT allows double path separators in file names so saving
          the g7towin.ini file to 'C:\\g7towin.ini' works under NT.
          It fails under 95.  I added a check for the double '\' and
          remove it.  The path where the .ini file is to be saved is
          also displayed.

======================================================================

Beta 58:  Fixed a Ozi waypoint read problem.  This caused waypoints
          read from ozi files to have the comment duplicated.

======================================================================

Beta 57:  Cleaned up a bit in the SA file handling routines.

          Misc bug fixes.

          NOTE:  I have decided to take advantage of Garmin's update
                 program for the G3 and have returned it to Garmin.
                 Until I get the G3+ from Garmin I have no means of
                 testing Garmin related code.  If you report a problem
                 with Garmin related function please be exact.  If 
                 your comments are brief I won't be able to find the
                 problem.

======================================================================

Beta 56:  Fixed a problem with the title bar.  It didn't properly
          reflect the state of the GPS and port speed.

======================================================================

Beta 55:  Output datum is now saved in the .ini file.

          Fixed a bug in the N/S display routines for EditBoxs.

======================================================================

Beta 54:  Total re-write of bitmap display routines.  The program now
          includes pseudo-zoom, i.e.  the bitmap can be 'zoomed' to the
          size of the client window.  If you wish a bigger display of
          the bitmap simply size G7ToWin's main window a little larger.
          The bitmap can be rotated 90 degrees to the left.  Both
          commands can be accessed by shortcut keys.  CTRL-Z to toggle
          zoom and CTRL-L to rotate left.  When the bitmap is saved to a
          file it is saved in the orientation that is currently
          displayed.

          Did some route 0 cleanup for SA routes.  I still need to give
          this some thoughts.  If you use routes and use SA5 or SA6 and
          have some thoughts as to how G7ToWin should handle the
          START/FINISH situation please let me know.  I do not use the
          route 0 on SA very much.

          Fixed several small bugs that were triggered by reading data
          from any source, clearing that data and then re-reading the
          data.

======================================================================

Beta 53:  Fixed a problem in reading tracks from Garmin units.  The
          N/S and E/W variable wasn't set which caused problems with
          several routines.

======================================================================

Beta 52:  Fixed a problem in reading tracks from SA files.  This bug
          usually resulted in G7ToWin crashing if the read file was
          saved to any file type which accepted routes.

          Moved some icons around in the table so that all GIII+ icons
          have an SA counterpart.  The actual matchups may not make
          too much sense, but at least icons won't be defaulted.

======================================================================

Beta 51:  Added Icon Family selection to the Icon Property dialog box.

          When changing the name of a waypoint and that waypoint was
          in routes, the name in the route wasn't changed.  Fixed

          Added a 'Save Configuration' button to the Edit Waypoint
          dialog box.

          Fixed a read problem which cut off the last digit of lat/long
          if the input format was DMS in a .txt file.

======================================================================

Beta 50:  Uploading or downloading 'All' does not include the Almanac.
          The almanac must be uploaded or downloaded separately.

          Menu grey cleanup.  
          
          Added serial debug file enable to File->Configuration and
          removed it from command line check.

======================================================================

Beta 49:  Added a few keyboard acclerators.  Check the menu for which
          they are.  If I get suggestions for more I'll consider adding
          them.

======================================================================

Beta 48:  Added the 8 Icons added to the GPSIII+.  They are bracketed
          by '+' signs in the icon selector drop down box.

======================================================================

Beta 47:  G7ToWin accepts files 'dropped' on it as input.  Be careful.
          Input files are assumed valid.  A bad file will crash the
          program.

======================================================================

Beta 46:  Added check for and clear of SA dialog box before sending data.

          Swapped two main menu items and their status bar help.

          Added check for Street Atlas dialog box before sending data.

          Turned off editing of waypoint data in the waypoint list.
          This was supposed to be turned off already, but a line of
          code was mistakenly removed.  The proper way to edit a
          waypoint is to double click on it.

======================================================================

Beta 45:  Added the ability to send data to an executing Street Atlas
          window.  This will not work with SA4 at this time, and SA5
          has not been tested.  It works with SA6 ok.  The procedure
          is to load your data, either from the GPS or a file, then
          select Send to GPS from the main menu.

          Misc cleanup.

======================================================================

Beta 44:  Did more work on line parameters for SA.

======================================================================

Beta 43:  Added Route line properties to SA Route/Track Option dialog
          box.

======================================================================

Beta 42:  Icons caused a problem on waypoint output to SA files. I
          think it's fixed.

======================================================================

Beta 41:  Cleaned up some SA6 & route code.

          Changed the way the number of SA objects is counted.

          Removed the option to 'draw route 0'.  It wasn't
          needed.  If draw route 0 line and draw route 0
          waypoints are both 0 the route won't be drawn.

          Added option to output route 0 as an SA route.  Tested
          only with SA6.

======================================================================

Beta 40:  Fixed a route0 output to SA6 problem.

          All items under File->Configuration are now saved on press of
          the 'Save configuration' button in any one of the
          File->Configuration pages.  The program no longer saves the
          state of the current configuration on program exit, only on
          a 'Save configuration' button press.
======================================================================

Beta 39:  Fixed a crash which occurred when saving route 0 to a .SA file.

          Fixed a waypoint list problem.  The E/W character was displayed
          in the latitude box

          Deleting all the waypoints in a route now causes the route tree
          list box to expand the route names.  Before it was totally 
          collapsed after deleting all route points in a route.
======================================================================

Beta 38:  The number of route points is limited to 99.  Editing a route now 
          checks this number.

          Added audio prompts to moving waypoints within a route.

          Fixed a 'reading of g7towin.ini' problem.
======================================================================

Beta 37:  Added progress bar to Garmin Screen download

          Made some changes to the Street Pilot code.  I have no way of testing
          this code.  If you have a SP and encounter problems please let me know.

          Added the ability to re-order the waypoints in a route.  This uses
          buttons and is not drag and drop.
======================================================================

Beta 36:  Fixed a waypoint problem when waypoint was downloaded from the Garmin
======================================================================

Beta 35:  Fixed a route download problem

          Fixed a route upload problem

          Added a few upload/download progress bars.  More need to be added.
======================================================================

Beta 34:  Added almanac download/upload from Garmin units and output to
          a .alm file.  It is not thoroughly tested at this
          time, but it appears to work.  The .alm file should be exactly
          the same format as file saved by the program.  This is 
          supposed to be YUMA format, but, again, it hasn't been
          extensively tested.

          Centered dialog boxes around main window

          Added GPS mfg to Status Bar
======================================================================

Beta 33:  Increased # of waypoints and tracks allowed to be 100000 or
          limited by 'memory' whichever is less.

          g7towin.ini was being written to the last directory
          which had a file read or written.  Fixed.  g7towin.ini
          is now written to the g7towin startup directory.

          Moved selection of the GPS to the File->Configuration->General
          tab.

          Status bar menu tips now work.
======================================================================

Beta 32:  Fixed an improper mode in the opening of text files.  This
          error was inadvertently introduced in version Beta 31
======================================================================
          
Beta 31:  Moved COM port selection and baud rate selection from the main
          title bar to the File->Conviguration->General setup tab
======================================================================

======================================================================
===========================  NOTES SECTION ===========================
======================================================================


The URL for my G7ToWin website is

http://www.gpsinformation.org/ronh/g7towin.htm

My email address is available there
======================================================================

NOTE: G7ToWin requires version 5.8 or later of comctl32.dll, the
      common controls dll.  If your system does not have this version or
      a newer version installed then some of the controls will not work
      correctly.

      To use the context sensitive help functions available starting with
      version A.00.163 you must have version 5.8 or later of
      comctl32.dll.  A suitable version of this dll is provided with all
      versions of Internet Explorer 5.0 and above.  For Windows 95/98/Me
      you must have the Microsoft Layer for Unicode installed on your
      machine.  This can be obtained from Microsoft.

      NOTE: If running on a Win95 or Win98 PC which does not support
            USB you may receive the following error message at startup:

            The G7TOWIN.EXE file is linked to missing export
            SETUPAPI.DLL:SetupDiGetDeviceInterfaceDetailA

            You may ignore this message for the function will not be 
            used unless you attempt to access a USB Garmin unit.

            If your OS does not allow missing entry points to be
            ignored you may download the current version of G7ToWin
            compiled without USB support from:

            http://www.gpsinformation.org/ronh/g7towinNoUSB.zip

      NOTE: Garmin has changed the display download routines for the 
            later units, however, Garmin's own xImage works well to 
            download the display of these later units and it is not 
            likely that G7ToWin will be updated to support them.

      If you have questions concerning the 'Monitoring functions' you
      can direct them to:

        Timo-Enrique Koester 
        email:  koestert@students.uni-mainz.de 

